/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
var __webpack_exports__ = {};

;// CONCATENATED MODULE: ./src/extension/data/accountActionSequence.ts
const accountActionSequences = {
    STK: {
        email: [
            {
                action: "clickButton",
                selectorText: "wallet",
                attribute: "data-test",
                element: "button",
            },
            {
                action: "clickButton",
                selectorText: "wallet",
                textContents: "Daily Bonus",
                attribute: "data-test",
                element: "button",
            },
            {
                action: "clickButton",
                selectorText: "contents",
                textContents: "claim",
                attribute: "class",
                element: "div",
            },
            {
                action: "navigate",
                URL: "https://www.stake.us",
            },
            {
                action: "clickButton",
                selectorText: "contents",
                textContents: "claim",
                attribute: "class",
                element: "div",
            },
            {
                action: "clickButton",
                selectorText: "gold",
                attribute: "title",
                element: "span",
            },
            {
                action: "clickButton",
                attribute: "title",
                element: "span",
                selectorText: "sweeps",
                duration: 3000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "class",
                selectorText: "icon",
                slug: "STK",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "coin",
                duration: 8000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "close",
            //   element: "button",
            //   attribute: "class",
            //   duration: 600000,
            // },
        ],
    },
    FC: {
        email: [
            {
                action: "clickButton",
                selectorText: "button",
                attribute: "type",
                element: "button",
                textContents: "log",
                parentSelectorText: "header",
                parentElement: "div",
                parentAttribute: "class",
            },
            {
                action: "type",
                slug: "FC",
                userSelector: "input[name='username']",
                passSelector: "input[name='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "login",
                attribute: "class",
                element: "button",
                textContents: "log",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "terms-conditions",
                attribute: "id",
                element: "input",
                duration: 10000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "confirm",
            },
            {
                action: "clickButton",
                selectorText: "close",
                element: "button",
                attribute: "class",
            },
            {
                action: "clickButton",
                selectorText: "coin-store-button",
                element: "button",
                attribute: "class",
            },
            {
                action: "clickButton",
                element: "button",
                attribute: "class",
                selectorText: "daily",
                textContents: "collect",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "daily",
            },
            {
                action: "clickButton",
                selectorText: "close",
                element: "button",
                attribute: "class",
            },
            // {
            //   action: "navigate",
            //   URL: "https://www.fortunecoins.com/lobby",
            // },
            {
                action: "findVal",
                element: "span",
                slug: "FC",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "desktop",
                duration: 11000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "close",
            //   element: "button",
            //   attribute: "class",
            //   duration: 600000,
            // },
        ],
    },
    Chumba: {
        email: [
            {
                action: "clickButton",
                selectorText: "login",
                attribute: "href",
                element: "a",
                textContents: "log",
            },
            {
                action: "type",
                slug: "Chumba",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "log",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "button",
                attribute: "class",
                selectorText: "nav",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "hud",
            },
            {
                action: "clickButton",
                selectorText: "buy",
                attribute: "class",
                element: "button",
                textContents: "get",
            },
            {
                action: "clickButton",
                selectorText: "tab",
                attribute: "class",
                element: "label",
                textContents: "daily",
            },
            {
                action: "clickButton",
                selectorText: "daily",
                attribute: "id",
                element: "button",
                textContents: "claim",
            },
            {
                action: "navigate",
                URL: "https://lobby.chumbacasino.com/",
                duration: 10000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "class",
                selectorText: "value",
                slug: "Chumba",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "toggle",
                duration: 8000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "daily",
            //   attribute: "id",
            //   element: "button",
            //   textContents: "claim",
            //   duration: 45000,
            // },
        ],
    },
    Cha: {
        email: [
            // {
            //   action: "clickButton",
            //   selectorText: "header",
            //   attribute: "class",
            //   element: "button",
            //   textContents: "log",
            // },
            // {
            //   action: "type",
            //   slug: "Cha",
            //   userSelector: "input[type='text']",
            //   passSelector: "input[type='password']",
            // },
            // {
            //   action: "clickButton",
            //   selectorText: "btn",
            //   attribute: "class",
            //   element: "button",
            //   textContents: "sign",
            //   duration: 8000,
            // },
            {
                action: "clickButton",
                selectorText: "-",
                attribute: "class",
                element: "span",
                textContents: "wallet",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "inline",
                attribute: "class",
                element: "button",
                textContents: "daily",
            },
            {
                action: "clickButton",
                selectorText: "btn",
                attribute: "class",
                element: "button",
                textContents: "claim",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "button",
                attribute: "type",
                element: "button",
                textContents: "yes",
                duration: 8000,
            },
            {
                action: "findVal",
                element: "span",
                slug: "Cha",
                parentElement: "button",
                parentAttribute: "id",
                parentSelectorText: "headlessui",
                duration: 8000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "daily",
            //   attribute: "id",
            //   element: "button",
            //   textContents: "claim",
            //   duration: 45000,
            // },
        ],
    },
    SPRT: {
        email: [
            {
                action: "clickButton",
                selectorText: "login",
                attribute: "class",
                element: "button",
                textContents: "log",
                duration: 3000,
            },
            {
                action: "type",
                slug: "SPRT",
                userSelector: "input[id='emailAddress']",
                passSelector: "input[id='password']",
                duration: 6000,
            },
            {
                action: "clickButton",
                selectorText: "login-form",
                attribute: "class",
                element: "button",
                textContents: "log",
                parentSelectorText: "login-button",
                parentElement: "div",
                parentAttribute: "class",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "header",
                attribute: "class",
                element: "span",
                textContents: "free",
                duration: 5000,
            },
            {
                action: "clickButton",
                selectorText: "coin-store",
                attribute: "class",
                element: "button",
                textContents: "collect",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "daily-bonus",
            },
            // {
            //   action: "clickButton",
            //   selectorText: "closePopup",
            //   attribute: "class",
            //   element: "button",
            // },
            {
                action: "navigate",
                URL: "https://sportzino.com/",
            },
            {
                action: "clickButton",
                selectorText: "balance-currency",
                attribute: "class",
                element: "span",
                duration: 8000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "class",
                selectorText: "balance",
                slug: "SPRT",
                parentElement: "span",
                parentAttribute: "class",
                parentSelectorText: "balance-switcher",
                duration: 8000,
            },
        ],
        google: [
            {
                action: "navigate",
                URL: "https://sportzino.com/login",
            },
            {
                action: "clickButton",
                element: "span",
                attribute: "class",
                selectorText: "button",
                textContents: "log in with google",
            },
            {
                action: "switchTab",
                authMethod: "google",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "UserKeys",
                accountId: "SPRT",
            },
            {
                action: "clickButton",
                selectorText: "terms-conditions",
                attribute: "id",
                element: "input",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "input",
                attribute: "id",
                element: "terms-conditions",
                textContents: "close",
            },
            {
                action: "clickButton",
                selectorText: "closePopup",
                attribute: "class",
                element: "button",
            },
            {
                action: "clickButton",
                selectorText: "header-auth",
                attribute: "class",
                element: "button",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "header-auth-section",
            },
            {
                action: "clickButton",
                selectorText: "coin",
                attribute: "class",
                element: "button",
                textContents: "collect",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "daily",
            },
            {
                action: "clickButton",
                selectorText: "closePopup",
                attribute: "class",
                element: "button",
            },
            {
                action: "clickButton",
                selectorText: "balance",
                attribute: "class",
                element: "button",
            },
            {
                action: "findVal",
                element: "span",
                attribute: "class",
                selectorText: "balance",
                slug: "SPRT",
                parentElement: "span",
                parentAttribute: "class",
                parentSelectorText: "balance-switcher",
            },
            // {
            //   action: "clickButton",
            //   selectorText: "close",
            //   element: "button",
            //   attribute: "class",
            //   duration: 600000,
            // },
        ],
    },
    GP: {
        email: [
            {
                action: "navigate",
                URL: "https://play.globalpoker.com/login?platform=globalpoker.com",
                duration: 6000,
            },
            {
                action: "type",
                slug: "GP",
                userSelector: "input[type='email']",
                passSelector: "input[type='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "submit",
                attribute: "class",
                element: "span",
                textContents: "log in",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "cashier-button",
                attribute: "id",
                element: "button",
                textContents: "coins",
            },
            {
                action: "clickButton",
                selectorText: "daily-bonus",
                attribute: "id",
                element: "div",
            },
            {
                action: "navigate",
                URL: "https://play.globalpoker.com/",
                duration: 6000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "class",
                selectorText: "x",
                slug: "GP",
                parentElement: "div",
                parentAttribute: "id",
                parentSelectorText: "sc-balance",
                duration: 10000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "close",
            //   element: "button",
            //   attribute: "class",
            //   duration: 600000,
            // },
        ],
        google: [
            {
                action: "navigate",
                URL: "https://play.globalpoker.com/login?platform=globalpoker.com",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "google",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "UserKeys",
                accountId: "GP",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "continue",
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "continue",
            },
            // {
            //   action: "clickButton",
            //   selectorText: "submit",
            //   attribute: "class",
            //   element: "span",
            //   textContents: "log in",
            //   duration: 10000,
            // },
            {
                action: "clickButton",
                selectorText: "cashier-button",
                attribute: "id",
                element: "button",
                textContents: "coins",
            },
            {
                action: "clickButton",
                selectorText: "daily-bonus",
                attribute: "id",
                element: "div",
            },
            {
                action: "findVal",
                element: "span",
                attribute: "class",
                selectorText: "x",
                slug: "GP",
                parentElement: "div",
                parentAttribute: "id",
                parentSelectorText: "sc-balance",
                duration: 10000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "close",
            //   element: "button",
            //   attribute: "class",
            //   duration: 600000,
            // },
        ],
    },
    Zula: {
        email: [
            {
                action: "clickButton",
                selectorText: "button",
                attribute: "type",
                element: "button",
                textContents: "log",
                duration: 5000,
            },
            {
                action: "type",
                slug: "Zula",
                userSelector: "input[name='username']",
                passSelector: "input[name='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "button",
                attribute: "type",
                element: "button",
                textContents: "log in",
                duration: 9000,
            },
            {
                action: "clickButton",
                selectorText: "terms",
                element: "input",
                attribute: "id",
                duration: 4000,
            },
            {
                action: "clickButton",
                selectorText: "button",
                element: "button",
                attribute: "type",
                textContents: "confirm",
                duration: 2000,
            },
            {
                action: "clickButton",
                element: "button",
                attribute: "class",
                selectorText: "buttonBuy",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "headerButtons",
                duration: 3000,
            },
            {
                action: "clickButton",
                element: "button",
                attribute: "class",
                selectorText: "collect",
                textContents: "collect",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "coinsContainer",
            },
            {
                action: "clickButton",
                selectorText: "close",
                element: "button",
                attribute: "class",
            },
            {
                action: "clickButton",
                selectorText: "SC",
                element: "img",
                attribute: "alt",
            },
            {
                action: "findVal",
                element: "span",
                slug: "Zula",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "Decimals",
                duration: 10000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "close",
            //   element: "button",
            //   attribute: "class",
            //   duration: 600000,
            // },
        ],
        google: [
            {
                action: "clickButton",
                selectorText: "button",
                attribute: "type",
                element: "button",
                textContents: "log",
            },
            {
                action: "clickButton",
                element: "span",
                attribute: "class",
                selectorText: "button",
                textContents: "log in with google",
            },
            {
                action: "switchTab",
                authMethod: "google",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "UserKeys",
                accountId: "Zula",
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "UserKeys",
                accountId: "Zula",
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "continue",
            },
            {
                action: "clickButton",
                selectorText: "terms",
                element: "input",
                attribute: "id",
            },
            {
                action: "clickButton",
                selectorText: "button",
                element: "button",
                attribute: "type",
                textContents: "confirm",
            },
            {
                action: "clickButton",
                element: "button",
                attribute: "class",
                selectorText: "buttonBuy",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "headerButtons",
            },
            {
                action: "clickButton",
                element: "button",
                attribute: "class",
                selectorText: "collect",
                textContents: "collect",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "coinsContainer",
            },
            {
                action: "clickButton",
                selectorText: "close",
                element: "button",
                attribute: "class",
            },
            {
                action: "navigate",
                URL: "https://www.zulacasino.com/lobby",
            },
            {
                action: "findVal",
                element: "span",
                attribute: "",
                selectorText: "",
                slug: "Zula",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "text",
            },
            // {
            //   action: "clickButton",
            //   selectorText: "close",
            //   element: "button",
            //   attribute: "class",
            //   duration: 600000,
            // },
        ],
    },
    Modo: {
        email: [
            {
                action: "clickButton",
                attribute: "class",
                element: "span",
                textContents: "Log",
                duration: 5000,
            },
            {
                action: "clickButton",
                attribute: "class",
                element: "span",
                textContents: "xyzxyz",
                duration: 14000,
            },
            {
                action: "type",
                slug: "Modo",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
                duration: 7000,
            },
            {
                action: "clickButton",
                attribute: "class",
                element: "span",
                selectorText: "submit",
                textContents: "log",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "laim",
                duration: 8000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "",
                selectorText: "",
                slug: "Modo",
                parentElement: "p",
                parentAttribute: "class",
                parentSelectorText: "root",
                duration: 7000,
            },
        ],
        google: [
            {
                action: "clickButton",
                element: "button",
                textContents: "login",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "google",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "UserKeys",
                accountId: "Modo",
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "laim",
                duration: 10000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "",
                selectorText: "",
                slug: "Modo",
                parentElement: "p",
                parentAttribute: "class",
                parentSelectorText: "root",
                duration: 10000,
            },
            // {
            //   action: "findVal",
            //   element: "span",
            //   attribute: "",
            //   selectorText: "",
            //   slug: "Modo",
            //   parentElement: "p",
            //   parentAttribute: "class",
            //   parentSelectorText: "root",
            //   duration: 1000000,
            // },
        ],
    },
    RR: {
        email: [
            {
                action: "clickButton",
                selectorText: "button",
                attribute: "type",
                element: "button",
                textContents: "Login",
                duration: 8000,
            },
            {
                action: "type",
                slug: "RR",
                userSelector: "input[id='email']",
                passSelector: "input[id='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "submit",
                attribute: "type",
                element: "button",
                textContents: "sign in",
                duration: 9000,
            },
            {
                action: "clickButton",
                textContents: "Get coins",
                element: "span",
                duration: 7000,
            },
            {
                action: "clickButton",
                selectorText: "daily",
                element: "label",
                attribute: "id",
                textContents: "bonus",
            },
            {
                action: "clickButton",
                selectorText: "btn",
                element: "button",
                attribute: "class",
                textContents: "claim",
            },
            {
                action: "clickButton",
                selectorText: "close-icon",
                attribute: "class",
                element: "span",
            },
            {
                action: "findVal",
                element: "span",
                attribute: "",
                selectorText: "",
                slug: "RR",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "sc-coin",
                duration: 8000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "close",
            //   element: "button",
            //   attribute: "class",
            //   duration: 60000,
            // },
        ],
    },
    WowVegas: {
        email: [
            {
                action: "clickButton",
                selectorText: "login",
                attribute: "href",
                element: "a",
                textContents: "login",
            },
            {
                action: "type",
                slug: "WowVegas",
                userSelector: "input[id='email']",
                passSelector: "input[id='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "log in",
                duration: 7000,
            },
            {
                action: "navigate",
                URL: "https://www.wowvegas.com/promotions/daily-coin-reward",
                duration: 5000,
            },
            {
                action: "clickButton",
                selectorText: "items",
                attribute: "class",
                element: "button",
                parentElement: "article",
                parentAttribute: "class",
                parentSelectorText: "prose",
                duration: 10000,
            },
            {
                action: "clickButton",
                selectorText: "wheel",
                attribute: "class",
                element: "div",
                duration: 10000,
            },
            {
                action: "navigate",
                URL: "https://www.wowvegas.com/promotions/daily-coin-reward",
                duration: 5000,
            },
            {
                action: "clickButton",
                selectorText: "VBC",
                attribute: "alt",
                element: "img",
                duration: 6000,
            },
            {
                action: "clickButton",
                selectorText: "WOC",
                attribute: "alt",
                element: "img",
                duration: 5000,
            },
            {
                action: "findVal",
                element: "div",
                attribute: "class",
                selectorText: "flex",
                slug: "WowVegas",
                parentElement: "button",
                parentAttribute: "id",
                parentSelectorText: "headlessui",
                duration: 10000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "close",
            //   element: "button",
            //   attribute: "class",
            //   duration: 600000,
            // },
        ],
    },
    Sweep: {
        email: [
            {
                action: "clickButton",
                selectorText: "login",
                attribute: "class",
                element: "div",
                textContents: "sign in",
                duration: 8000,
            },
            {
                action: "type",
                slug: "Sweep",
                userSelector: "input[id='poplogin_email']",
                passSelector: "input[id='poplogin_password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "login",
                attribute: "id",
                element: "button",
                textContents: "log",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "claim",
                attribute: "id",
                element: "div",
                textContents: "claim",
            },
            {
                action: "clickButton",
                selectorText: "close",
                attribute: "id",
                element: "div",
            },
            {
                action: "clickButton",
                selectorText: "close",
                attribute: "id",
                element: "i",
            },
            {
                action: "clickButton",
                selectorText: "btn",
                attribute: "class",
                element: "div",
                textContents: "claim",
            },
            {
                action: "clickButton",
                selectorText: "close",
                attribute: "id",
                element: "div",
            },
            {
                action: "clickButton",
                selectorText: "whl-btn",
                attribute: "id",
                element: "div",
            },
            {
                action: "clickButton",
                selectorText: "wheel_spin",
                attribute: "id",
                element: "div",
            },
            {
                action: "clickButton",
                selectorText: "wheel_spin",
                attribute: "id",
                element: "div",
            },
            {
                action: "navigate",
                URL: "https://sweepslots.com/",
                duration: 10000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "class",
                selectorText: "gct",
                slug: "Sweep",
                duration: 10000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "close",
            //   element: "button",
            //   attribute: "class",
            //   duration: 600000,
            // },
        ],
    },
    Hi5: {
        email: [
            {
                action: "clickButton",
                element: "div",
                textContents: "log",
                parentElement: "button",
                parentAttribute: "class",
                parentSelectorText: "login",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "log in",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "email",
                duration: 8000,
            },
            {
                action: "type",
                slug: "Hi5",
                userSelector: "input[type='email']",
                passSelector: "input[type='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                selectorText: "signIn",
                duration: 3000,
            },
            {
                action: "clickButton",
                selectorText: "sweeps-claim",
                attribute: "class",
                element: "button",
                duration: 7000,
            },
            {
                action: "clickButton",
                selectorText: "sweeps-claim",
                attribute: "class",
                element: "div",
                textContents: "claim",
            },
            {
                action: "clickButton",
                selectorText: "sweeps-claim",
                attribute: "class",
                element: "button",
            },
            {
                action: "clickButton",
                selectorText: "sweeps-claim",
                attribute: "class",
                element: "div",
                textContents: "claim",
                duration: 8000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "class",
                selectorText: "sweeps-balance",
                slug: "Hi5",
                duration: 8000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "sweeps-top-bar",
            //   attribute: "class",
            //   element: "button",
            //   duration: 100000,
            // },
        ],
    },
    Pulsz: {
        email: [
            {
                action: "clickButton",
                selectorText: "",
                attribute: "class",
                element: "button",
                textContents: "claim",
            },
            {
                action: "navigate",
                URL: "https://www.pulsz.com",
                duration: 10000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "data-test",
                slug: "Pulsz",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "curency",
            },
            // {
            //   action: "clickButton",
            //   selectorText: "daily",
            //   attribute: "id",
            //   element: "button",
            //   textContents: "claim",
            //   duration: 45000,
            // },
        ],
    },
    VegasGems: {
        email: [
            {
                action: "navigate",
                URL: "https://vegasgems.com/rewards/daily/claim",
            },
            {
                action: "navigate",
                URL: "https://vegasgems.com",
                duration: 10000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "",
                selectorText: "",
                slug: "VegasGems",
                parentElement: "span",
                parentAttribute: "class",
                parentSelectorText: "user-balance",
                duration: 10000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "close",
            //   element: "button",
            //   attribute: "class",
            //   duration: 600000,
            // },
        ],
    },
    Spree: {
        email: [
            {
                action: "clickButton",
                element: "span",
                textContents: "log in",
            },
            {
                action: "type",
                slug: "Spree",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "submit",
                attribute: "type",
                element: "button",
                parentElement: "form",
                parentAttribute: "data-cy",
                parentSelectorText: "login",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "input",
                attribute: "type",
                selectorText: "checkbox",
            },
            {
                action: "clickButton",
                element: "span",
                attribute: "class",
                textContents: "accept",
            },
            {
                action: "navigate",
                URL: "https://spree.com/",
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "laim",
                duration: 8000,
            },
            {
                action: "findVal",
                element: "number-flow-react",
                attribute: "aria-label",
                slug: "Spree",
                duration: 8000,
            },
        ],
    },
    Ruby: {
        email: [
            {
                action: "clickButton",
                selectorText: "block",
                attribute: "class",
                element: "span",
                textContents: "log",
                duration: 8000,
            },
            {
                action: "type",
                slug: "Ruby",
                userSelector: "input[type='email']",
                passSelector: "input[type='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "block",
                attribute: "class",
                element: "span",
                textContents: "log",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "block",
                attribute: "class",
                element: "span",
                textContents: "spin",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "block",
                attribute: "class",
                element: "span",
                textContents: "spin",
            },
            {
                action: "navigate",
                URL: "https://play.rubysweeps.com/",
            },
            {
                action: "findVal",
                element: "a",
                attribute: "class",
                selectorText: "balance",
                slug: "Ruby",
                duration: 10000,
            },
        ],
    },
    Jefe: {
        email: [
            {
                action: "clickButton",
                selectorText: "button",
                attribute: "type",
                element: "button",
                textContents: "login",
            },
            {
                action: "type",
                slug: "Jefe",
                userSelector: "input[id='email']",
                passSelector: "input[id='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "submit",
                attribute: "type",
                element: "button",
                textContents: "sign",
                duration: 9000,
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "accept",
            },
            {
                action: "clickButton",
                selectorText: "getcoin",
                attribute: "class",
                element: "button",
                parentSelectorText: "header",
                parentElement: "div",
                parentAttribute: "class",
            },
            {
                action: "clickButton",
                selectorText: "daily",
                element: "label",
                attribute: "id",
                textContents: "daily",
            },
            {
                action: "clickButton",
                selectorText: "btn",
                element: "button",
                attribute: "class",
                textContents: "claim",
            },
            {
                action: "clickButton",
                selectorText: "close-icon",
                attribute: "class",
                element: "span",
            },
            {
                action: "navigate",
                URL: "https://www.jefebet.com/",
                duration: 7090,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "",
                selectorText: "",
                slug: "Jefe",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "sc-coin",
                duration: 11000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "close",
            //   element: "button",
            //   attribute: "class",
            //   duration: 600000,
            // },
        ],
    },
    RealPrize: {
        email: [
            {
                action: "clickButton",
                selectorText: "menulogin",
                attribute: "class",
                element: "div",
                textContents: "login",
                duration: 8000,
            },
            {
                action: "type",
                slug: "RealPrize",
                userSelector: "input[type='email']",
                passSelector: "input[type='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "login",
                attribute: "id",
                element: "button",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                selectorText: "btn",
                textContents: "claim",
                duration: 5000,
            },
            {
                action: "navigate",
                URL: "https://realprize.com/",
                duration: 6000,
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                selectorText: "btn",
                textContents: "claim",
                duration: 5000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "class",
                selectorText: "gct",
                slug: "RealPrize",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "gcnum",
                duration: 9000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "close",
            //   element: "button",
            //   attribute: "class",
            //   duration: 600000,
            // },
        ],
    },
    Crown: {
        email: [
            // {
            //   action: "clickButton",
            //   element: "button",
            //   textContents: "log in",
            // },
            // {
            //   action: "type",
            //   slug: "Crown",
            //   userSelector: "input[name='email']",
            //   passSelector: "input[name='password']",
            //   duration: 8000,
            // },
            // {
            //   action: "clickButton",
            //   element: "div",
            //   attribute: "class",
            //   selectorText: "button",
            //   textContents: "log in",
            // },
            {
                action: "clickButton",
                element: "div",
                attribute: "id",
                selectorText: "close",
                duration: 3000,
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "pin",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                selectorText: "button",
                textContents: "laim",
                duration: 3000,
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "pin",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "button",
                attribute: "class",
                selectorText: "button",
                duration: 5000,
            },
            // {
            //   action: "clickButton",
            //   element: "div",
            //   attribute: "class",
            //   selectorText: "menuToggle",
            // },
            {
                action: "clickButton",
                element: "button",
                attribute: "class",
                selectorText: "menu",
                textContents: "rewards",
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                selectorText: "button",
                textContents: "view",
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                selectorText: "day",
                textContents: "day",
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                selectorText: "day",
                textContents: "day",
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "id",
                selectorText: "close",
            },
            {
                action: "clickButton",
                element: "picture",
                attribute: "class",
                selectorText: "game-type",
            },
            {
                action: "findVal",
                element: "div",
                attribute: "id",
                selectorText: "balance",
                slug: "Crown",
                parentElement: "div",
                parentAttribute: "id",
                parentSelectorText: "balance",
                duration: 10000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "close",
            //   element: "button",
            //   attribute: "class",
            //   duration: 600000,
            // },
        ],
    },
    LuckyBird: {
        email: [
            // {
            //   action: "clickButton",
            //   element: "div",
            //   textContents: "sign in",
            // },
            // {
            //   action: "type",
            //   slug: "LuckyBird",
            //   userSelector: "input[type='text']",
            //   passSelector: "input[type='password']",
            //   duration: 8000,
            // },
            // {
            //   action: "clickButton",
            //   element: "div",
            //   attribute: "class",
            //   selectorText: "button",
            //   textContents: "log in",
            // },
            {
                action: "clickButton",
                element: "span",
                textContents: "daily bonus",
                parentElement: "button",
                parentAttribute: "type",
                parentSelectorText: "button",
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "redeem",
                parentElement: "li",
                parentAttribute: "class",
                parentSelectorText: "redeem",
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                textContents: "daily bonus",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "nav",
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "daily bonus",
                parentElement: "button",
                parentAttribute: "type",
                parentSelectorText: "button",
            },
            {
                action: "clickButton",
                element: "picture",
                attribute: "class",
                selectorText: "game-type",
            },
            {
                action: "findVal",
                element: "span",
                attribute: "class",
                selectorText: "amount",
                slug: "LuckyBird",
            },
            // {
            //   action: "clickButton",
            //   selectorText: "close",
            //   element: "button",
            //   attribute: "class",
            //   duration: 600000,
            // },
        ],
    },
    PulszBingo: {
        email: [
            {
                action: "clickButton",
                attribute: "id",
                element: "canvas",
                selectorText: "canvas",
                duration: 8000,
            },
            {
                action: "clickButton",
                attribute: "id",
                element: "canvas",
                selectorText: "canvas",
                duration: 4000,
            },
            {
                action: "navigate",
                URL: "https://www.pulszbingo.com/",
                duration: 10000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "data-test",
                slug: "PulszBingo",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "curency",
                duration: 10000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "daily",
            //   attribute: "id",
            //   element: "button",
            //   textContents: "claim",
            //   duration: 45000,
            // },
        ],
    },
    ClubsPoker: {
        email: [
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                textContents: "login",
                duration: 11000,
            },
            {
                action: "type",
                slug: "ClubsPoker",
                userSelector: "input[name='username']",
                passSelector: "input[name='password']",
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                selectorText: "sign_in",
                textContents: "log in",
                duration: 10000,
            },
            // {
            //   action: "navigate",
            //   URL: "https://play.clubs.poker/",
            //   duration: 4000,
            // },
            // {
            //   action: "clickButton",
            //   element: "div",
            //   attribute: "class",
            //   selectorText: "Button",
            //   textContents: "close",
            // },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                selectorText: "Button",
                textContents: "get coins",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                selectorText: "Button",
                textContents: "collect now",
                duration: 12000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "class",
                selectorText: "value",
                slug: "ClubsPoker",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "Switch",
                duration: 10000,
            },
        ],
    },
    MoonSpin: {
        email: [
            {
                action: "clickButton",
                element: "button",
                textContents: "Log In",
            },
            {
                action: "type",
                slug: "MoonSpin",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
                duration: 9000,
            },
            {
                action: "clickButton",
                element: "button",
                attribute: "type",
                selectorText: "submit",
                textContents: "Log In",
                duration: 10000,
            },
            {
                action: "clickButton",
                attribute: "aria-label",
                element: "button",
                selectorText: "Bonuses",
                duration: 8000,
            },
            {
                action: "clickButton",
                attribute: "type",
                element: "button",
                selectorText: "button",
                textContents: "claim",
            },
            {
                action: "findVal",
                element: "span",
                attribute: "style",
                selectorText: "pointer-events",
                slug: "MoonSpin",
                duration: 8000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "daily",
            //   attribute: "id",
            //   element: "button",
            //   textContents: "claim",
            //   duration: 45000,
            // },
        ],
    },
    Kickr: {
        email: [
            {
                action: "clickButton",
                element: "div",
                textContents: "LOG",
            },
            {
                action: "type",
                slug: "Kickr",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
            },
            {
                action: "clickButton",
                element: "span",
                attribute: "class",
                selectorText: "auth",
                textContents: "log in",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "input",
                attribute: "type",
                selectorText: "checkbox",
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                selectorText: "button",
                textContents: "accept",
            },
            {
                action: "clickButton",
                element: "span",
                attribute: "class",
                selectorText: "store",
                textContents: "claim",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "Daily claims",
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                selectorText: "kickr",
                textContents: "claim",
            },
            // {
            //   action: "navigate",
            //   URL: "https://kickr.com/",
            //   duration: 8000,
            // },
            {
                action: "findVal",
                element: "span",
                attribute: "",
                selectorText: "",
                slug: "Kickr",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "currency",
                duration: 11000,
            },
        ],
        google: [
            {
                action: "clickButton",
                element: "div",
                textContents: "Log",
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                selectorText: "auth",
                textContents: "google",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "UserKeys",
                accountId: "Kickr",
            },
            {
                action: "clickButton",
                element: "label",
                attribute: "class",
                selectorText: "checkbox",
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                selectorText: "button",
                textContents: "accept",
            },
            {
                action: "clickButton",
                element: "span",
                attribute: "class",
                selectorText: "store",
                textContents: "claim",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "Daily claims",
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                selectorText: "kickr",
                textContents: "claim",
            },
            // {
            //   action: "navigate",
            //   URL: "https://kickr.com",
            // },
            {
                action: "findVal",
                element: "span",
                attribute: "",
                selectorText: "",
                slug: "Kickr",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "currency",
                duration: 10000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "",
                selectorText: "",
                slug: "Kickr",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "currency",
                duration: 6000,
            },
            // {
            //   action: "findVal",
            //   element: "span",
            //   attribute: "",
            //   selectorText: "",
            //   slug: "Modo",
            //   parentElement: "p",
            //   parentAttribute: "class",
            //   parentSelectorText: "root",
            //   duration: 1000000,
            // },
        ],
    },
    MyPrize: {
        email: [
            {
                action: "clickButton",
                element: "a",
                attribute: "class",
                selectorText: "login",
                textContents: "Log",
            },
            {
                action: "clickButton",
                element: "button",
                attribute: "class",
                selectorText: "login",
                textContents: "Log",
            },
            {
                action: "type",
                slug: "MyPrize",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "button",
                attribute: "type",
                selectorText: "submit",
                textContents: "log",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "button",
                attribute: "type",
                element: "button",
                textContents: "bonus",
            },
            {
                action: "clickButton",
                selectorText: "button",
                textContents: "Claim",
                attribute: "type",
                element: "button",
            },
            {
                action: "clickButton",
                textContents: "spin",
                element: "button",
            },
            {
                action: "navigate",
                URL: "https://myprize.us/",
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                selectorText: "SC",
            },
            {
                action: "findVal",
                element: "span",
                attribute: "class",
                selectorText: "amount",
                slug: "MyPrize",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "balance",
                duration: 8000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "close",
            //   element: "button",
            //   attribute: "class",
            //   duration: 600000,
            // },
        ],
    },
    Moozi: {
        email: [
            {
                action: "clickButton",
                element: "button",
                textContents: "Log",
            },
            {
                action: "type",
                slug: "Moozi",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "Log in",
                duration: 8000,
            },
            {
                action: "clickButton",
                attribute: "class",
                element: "span",
                textContents: "Daily",
            },
            {
                action: "clickButton",
                selectorText: "w",
                attribute: "class",
                element: "div",
                textContents: "Claim",
            },
            // {
            //   action: "navigate",
            //   URL: "https://myprize.us/",
            // },
            {
                action: "findVal",
                element: "span",
                attribute: "class",
                slug: "Moozi",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "coin",
                duration: 8000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "close",
            //   element: "button",
            //   attribute: "class",
            //   duration: 600000,
            // },
        ],
    },
    Punt: {
        email: [
            // {
            //   action: "clickButton",
            //   selectorText: "header",
            //   attribute: "class",
            //   element: "button",
            //   textContents: "log",
            // },
            // {
            //   action: "type",
            //   slug: "Punt",
            //   userSelector: "input[type='text']",
            //   passSelector: "input[type='password']",
            // },
            // {
            //   action: "clickButton",
            //   selectorText: "btn",
            //   attribute: "class",
            //   element: "button",
            //   textContents: "sign",
            //   duration: 8000,
            // },
            {
                action: "clickButton",
                selectorText: "-",
                attribute: "class",
                element: "span",
                textContents: "wallet",
                duration: 10000,
            },
            {
                action: "clickButton",
                selectorText: "inline",
                attribute: "class",
                element: "button",
                textContents: "daily",
            },
            {
                action: "clickButton",
                selectorText: "btn",
                attribute: "class",
                element: "button",
                textContents: "claim",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "button",
                attribute: "type",
                element: "button",
                textContents: "yes",
                duration: 8000,
            },
            {
                action: "findVal",
                element: "span",
                slug: "Punt",
                parentElement: "button",
                parentAttribute: "id",
                parentSelectorText: "headlessui",
                duration: 9000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "daily",
            //   attribute: "id",
            //   element: "button",
            //   textContents: "claim",
            //   duration: 90000,
            // },
        ],
    },
    Yay: {
        email: [
            {
                action: "clickButton",
                selectorText: "header-lobby",
                attribute: "class",
                element: "button",
                textContents: "log",
                duration: 8000,
            },
            {
                action: "type",
                slug: "Yay",
                userSelector: "input[name='username']",
                passSelector: "input[name='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "login",
                attribute: "class",
                element: "button",
                textContents: "log",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "button",
                attribute: "type",
                element: "button",
                textContents: "coin store",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "collect",
                attribute: "class",
                element: "button",
                textContents: "collect",
                duration: 8000,
            },
            {
                action: "navigate",
                URL: "https://www.yaycasino.us/lobby",
                duration: 8000,
            },
            {
                action: "findVal",
                element: "span",
                slug: "Yay",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "text",
                duration: 10000,
            },
        ],
    },
    YayCOM: {
        email: [
            {
                action: "clickButton",
                selectorText: "header-lobby",
                attribute: "class",
                element: "button",
                textContents: "log",
            },
            {
                action: "type",
                slug: "YayCOM",
                userSelector: "input[name='username']",
                passSelector: "input[name='password']",
            },
            {
                action: "clickButton",
                selectorText: "login",
                attribute: "class",
                element: "button",
                textContents: "log",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "button",
                attribute: "type",
                element: "button",
                textContents: "coin store",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "collect",
                attribute: "class",
                element: "button",
                textContents: "collect",
            },
            {
                action: "navigate",
                URL: "https://www.yaycasino.com/lobby",
            },
            {
                action: "findVal",
                element: "span",
                slug: "YayCOM",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "text",
                duration: 10000,
            },
        ],
    },
    Scrooge: {
        email: [
            {
                action: "clickButton",
                selectorText: "",
                attribute: "class",
                element: "button",
                textContents: "play",
            },
            {
                action: "type",
                slug: "Scrooge",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
            },
            {
                action: "clickButton",
                selectorText: "submit",
                attribute: "type",
                element: "button",
                textContents: "log",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "nav",
                attribute: "class",
                element: "a",
                textContents: "daily wheel",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "regular",
            },
            {
                action: "clickButton",
                attribute: "alt",
                element: "img",
                selectorText: "spin",
            },
            {
                action: "navigate",
                URL: "https://scrooge.casino/",
            },
            {
                action: "findVal",
                element: "p",
                slug: "Scrooge",
                parentElement: "label",
                parentAttribute: "class",
                parentSelectorText: "form-check",
                duration: 8000,
            },
        ],
    },
    Zoot: {
        email: [
            // {
            //   action: "clickButton",
            //   selectorText: "login",
            //   attribute: "data-test",
            //   element: "button",
            // },
            // {
            //   action: "type",
            //   slug: "Zoot",
            //   userSelector: "input[name='username']",
            //   passSelector: "input[name='password']",
            // },
            // {
            //   action: "clickButton",
            //   selectorText: "login",
            //   attribute: "class",
            //   element: "button",
            //   textContents: "log",
            //   duration: 8000,
            // },
            {
                action: "clickButton",
                element: "button",
                textContents: "spin",
            },
            {
                action: "clickButton",
                selectorText: "chakra",
                attribute: "class",
                element: "span",
                textContents: "daily",
                duration: 6000,
            },
            {
                action: "clickButton",
                selectorText: "chakra",
                attribute: "class",
                element: "span",
                textContents: "Claim",
            },
            {
                action: "clickButton",
                selectorText: "sweeps-inactive",
                attribute: "class",
                element: "div",
            },
            {
                action: "findVal",
                element: "span",
                attribute: "class",
                selectorText: "hz3a",
                slug: "Zoot",
                parentElement: "div",
                parentAttribute: "id",
                parentSelectorText: "zoot-balance",
                duration: 8000,
            },
        ],
    },
    Smiles: {
        email: [
            {
                action: "clickButton",
                element: "p",
                textContents: "log",
            },
            {
                action: "type",
                slug: "Smiles",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
            },
            {
                action: "clickButton",
                element: "p",
                textContents: "log",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "p",
                textContents: "Claim",
                duration: 8000,
            },
            // {
            //   action: "navigate",
            //   URL: "https://www.yaycasino.com/lobby",
            // },
            {
                action: "findVal",
                element: "div",
                attribute: "class",
                selectorText: "balance-panel",
                slug: "Smiles",
                duration: 10000,
            },
        ],
    },
    Juked: {
        email: [
            // {
            //   action: "clickButton",
            //   selectorText: "header",
            //   attribute: "class",
            //   element: "button",
            //   textContents: "log",
            // },
            // {
            //   action: "type",
            //   slug: "Juked",
            //   userSelector: "input[type='text']",
            //   passSelector: "input[type='password']",
            // },
            // {
            //   action: "clickButton",
            //   selectorText: "btn",
            //   attribute: "class",
            //   element: "button",
            //   textContents: "sign",
            //   duration: 8000,
            // },
            {
                action: "clickButton",
                selectorText: "-",
                attribute: "class",
                element: "span",
                textContents: "wallet",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "inline",
                attribute: "class",
                element: "button",
                textContents: "Hourly",
            },
            {
                action: "clickButton",
                selectorText: "btn",
                attribute: "class",
                element: "button",
                textContents: "claim",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "button",
                attribute: "type",
                element: "button",
                textContents: "yes",
                duration: 8000,
            },
            {
                action: "findVal",
                element: "span",
                slug: "Juked",
                parentElement: "button",
                parentAttribute: "id",
                parentSelectorText: "headlessui",
                duration: 8000,
            },
        ],
    },
    Spinpals: {
        email: [
            {
                action: "clickButton",
                element: "button",
                textContents: "login",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "log in",
                duration: 2000,
            },
            {
                action: "type",
                slug: "Spinpals",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "Log",
                parentElement: "div",
                parentAttribute: "data-headlessui-state",
                parentSelectorText: "open",
                duration: 8000,
            },
            {
                action: "navigate",
                URL: "https://www.spinpals.com/user/store",
                duration: 6000,
            },
            {
                action: "clickButton",
                element: "a",
                textContents: "daily",
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "Claim",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "Claim",
                duration: 4000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "xyzxyz",
                duration: 15000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "laim",
                duration: 6000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "ontinue",
                duration: 6000,
            },
            {
                action: "navigate",
                URL: "https://www.spinpals.com/lobby",
            },
            {
                action: "findVal",
                element: "p",
                attribute: "class",
                selectorText: "xs",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "urple",
                slug: "Spinpals",
                duration: 5000,
            },
        ],
    },
    GoldSlips: {
        email: [
            {
                action: "clickButton",
                selectorText: "block",
                attribute: "class",
                element: "span",
                textContents: "log",
            },
            {
                action: "type",
                slug: "GoldSlips",
                userSelector: "input[type='email']",
                passSelector: "input[type='password']",
            },
            {
                action: "clickButton",
                selectorText: "block",
                attribute: "class",
                element: "span",
                textContents: "log",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "block",
                attribute: "class",
                element: "span",
                textContents: "spin",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "block",
                attribute: "class",
                element: "span",
                textContents: "spin",
            },
            {
                action: "navigate",
                URL: "https://play.goldslips.com/",
            },
            {
                action: "findVal",
                element: "a",
                attribute: "class",
                selectorText: "balance",
                slug: "GoldSlips",
                duration: 10000,
            },
        ],
    },
    iCasino: {
        email: [
            {
                action: "clickButton",
                element: "a",
                textContents: "log in",
            },
            {
                action: "type",
                slug: "iCasino",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "log",
                duration: 7000,
            },
            {
                action: "navigate",
                URL: "https://app.icasino.com/",
            },
            {
                action: "clickButton",
                element: "svg",
                attribute: "class",
                selectorText: "menu",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "rewards",
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "view",
            },
            {
                action: "clickButton",
                element: "span",
                attribute: "class",
                selectorText: "day",
            },
            {
                action: "navigate",
                URL: "https://app.icasino.com/",
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "id",
                selectorText: "coin-switch",
            },
            {
                action: "findVal",
                element: "div",
                attribute: "data-testid",
                selectorText: "balance",
                slug: "iCasino",
                duration: 10000,
            },
        ],
        google: [
            {
                action: "clickButton",
                element: "a",
                textContents: "log in",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "google",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "UserKeys",
                accountId: "iCasino",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "continue",
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "continue",
            },
            {
                action: "navigate",
                URL: "https://app.icasino.com/",
            },
            {
                action: "clickButton",
                element: "svg",
                attribute: "class",
                selectorText: "menu",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "rewards",
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "view",
            },
            {
                action: "clickButton",
                element: "span",
                attribute: "class",
                selectorText: "day",
            },
            {
                action: "navigate",
                URL: "https://app.icasino.com/",
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "id",
                selectorText: "coin-switch",
            },
            {
                action: "findVal",
                element: "div",
                attribute: "data-testid",
                selectorText: "balance",
                slug: "iCasino",
                duration: 10000,
            },
        ],
    },
    Legendz: {
        email: [
            // {
            //   action: "clickButton",
            //   attribute: "class",
            //   element: "button",
            //   textContents: "log",
            // },
            // {
            //   action: "type",
            //   slug: "Legendz",
            //   userSelector: "input[id='login-email']",
            //   passSelector: "input[id='login-password']",
            // },
            // {
            //   action: "clickButton",
            //   element: "button",
            //   textContents: "log",
            //   duration: 8000,
            // },
            {
                action: "clickButton",
                element: "svg",
                attribute: "xmlns",
                selectorText: "2000",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "main",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "Play",
            },
            {
                action: "clickButton",
                selectorText: "spin",
                attribute: "style",
                element: "circle",
                duration: 1000,
            },
            //9x below
            // {
            //   action: "clickButton",
            //   selectorText: "spin",
            //   attribute: "style",
            //   element: "circle",
            //   duration: 1000,
            // },
            // {
            //   action: "clickButton",
            //   selectorText: "spin",
            //   attribute: "style",
            //   element: "circle",
            //   duration: 1000,
            // },
            // {
            //   action: "clickButton",
            //   selectorText: "spin",
            //   attribute: "style",
            //   element: "circle",
            //   duration: 1000,
            // },
            // {
            //   action: "clickButton",
            //   selectorText: "spin",
            //   attribute: "style",
            //   element: "circle",
            //   duration: 1000,
            // },
            // {
            //   action: "clickButton",
            //   selectorText: "spin",
            //   attribute: "style",
            //   element: "circle",
            //   duration: 1000,
            // },
            // {
            //   action: "clickButton",
            //   selectorText: "spin",
            //   attribute: "style",
            //   element: "circle",
            //   duration: 1000,
            // },
            // {
            //   action: "clickButton",
            //   selectorText: "spin",
            //   attribute: "style",
            //   element: "circle",
            //   duration: 1000,
            // },
            // {
            //   action: "clickButton",
            //   selectorText: "spin",
            //   attribute: "style",
            //   element: "circle",
            //   duration: 1000,
            // },
            // {
            //   action: "clickButton",
            //   selectorText: "spin",
            //   attribute: "style",
            //   element: "circle",
            //   duration: 1000,
            // },
            //
            {
                action: "navigate",
                URL: "https://www.legendz.com/",
            },
            {
                action: "findVal",
                element: "div",
                attribute: "class",
                selectorText: "css",
                parentElement: "header",
                parentAttribute: "data-testid",
                parentSelectorText: "main",
                slug: "Legendz",
                duration: 10000,
            },
        ],
    },
    SpinSorcery: {
        email: [
            // {
            //   action: "clickButton",
            //   element: "a",
            //   textContents: "log",
            //   duration: 10000,
            // },
            // {
            //   action: "type",
            //   slug: "SpinSorcery",
            //   userSelector: "input[id='email']",
            //   passSelector: "input[id='password']",
            //   duration: 8000,
            // },
            // {
            //   action: "clickButton",
            //   selectorText: "submit",
            //   attribute: "type",
            //   element: "button",
            //   textContents: "log",
            //   duration: 10000,
            // },
            // {
            //   action: "clickButton",
            //   element: "button",
            //   textContents: "laim",
            //   duration: 8000,
            // },
            // {
            //   action: "clickButton",
            //   element: "button",
            //   textContents: "ok",
            //   duration: 8000,
            // },
            // {
            //   action: "clickButton",
            //   element: "span",
            //   textContents: "laim",
            //   duration: 3000,
            // },
            // {
            //   action: "navigate",
            //   URL: "https://game.spinsorcery.net",
            //   duration: 8000,
            // },
            {
                action: "findVal",
                element: "p",
                attribute: "class",
                selectorText: "text-xs",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "text-xs",
                slug: "SpinSorcery",
                duration: 10000,
            },
        ],
    },
    Vivaro: {
        email: [
            {
                action: "clickButton",
                selectorText: "text",
                attribute: "data-testid",
                element: "div",
                textContents: "log",
                duration: 8000,
            },
            {
                action: "type",
                slug: "Vivaro",
                userSelector: "input[id='username']",
                passSelector: "input[id='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "text",
                attribute: "data-testid",
                element: "div",
                textContents: "log",
                duration: 8000,
            },
            {
                action: "clickButton",
                selectorText: "name",
                attribute: "class",
                element: "div",
                textContents: "bonus",
                duration: 6000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "auto",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "auto",
                duration: 5000,
            },
            {
                action: "navigate",
                URL: "https://www.vivaro.us/en-us/frame/daily-bonus",
                duration: 3000,
            },
            // {
            //   action: "clickButton",
            //   element: "span",
            //   textContents: "auto",
            //   duration: 7000,
            // },
            {
                action: "clickButton",
                selectorText: "currency",
                attribute: "data-testid",
                element: "div",
                duration: 10000,
            },
            {
                action: "findVal",
                element: "div",
                attribute: "class",
                selectorText: "name",
                parentElement: "div",
                parentAttribute: "class",
                parentSelectorText: "Currency",
                slug: "Vivaro",
                duration: 10000,
            },
        ],
    },
    McLuck: {
        email: [
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "header-login",
                duration: 5000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "header-login",
                duration: 12000,
            },
            {
                action: "type",
                slug: "McLuck",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "login-now",
                textContents: "log",
                duration: 7000,
            },
            {
                action: "navigate",
                URL: "https://www.mcluck.com/gold-coins",
                duration: 7000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "daily",
                textContents: "claim",
                duration: 5000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "daily",
                textContents: "rewards",
                duration: 6000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "xyz",
                duration: 18000,
            },
            {
                action: "navigate",
                URL: "https://www.mcluck.com/home",
            },
            {
                action: "findVal",
                element: "span",
                attribute: "data-test",
                selectorText: "sc",
                slug: "McLuck",
                duration: 7000,
            },
        ],
        google: [
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "header-login",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "google",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "UserKeys",
                accountId: "McLuck",
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "UserKeys",
                accountId: "McLuck",
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "login-now",
                textContents: "log",
                duration: 7000,
            },
            {
                action: "navigate",
                URL: "https://www.mcluck.com/gold-coins",
                duration: 7000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "daily",
                textContents: "claim",
                duration: 5000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "daily",
                textContents: "rewards",
                duration: 6000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "xyz",
                duration: 18000,
            },
            {
                action: "navigate",
                URL: "https://www.mcluck.com/home",
            },
            {
                action: "findVal",
                element: "span",
                attribute: "data-test",
                selectorText: "sc",
                slug: "McLuck",
                duration: 7000,
            },
        ],
    },
    HelloMillions: {
        email: [
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "header-login",
                duration: 5000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "header-login",
                duration: 12000,
            },
            {
                action: "type",
                slug: "HelloMillions",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "login-now",
                textContents: "log",
                duration: 7000,
            },
            {
                action: "navigate",
                URL: "https://www.hellomillions.com/gold-coins",
            },
            // {
            //   action: "clickButton",
            //   attribute: "class",
            //   element: "span",
            //   selectorText: "icon",
            //   duration: 2000,
            // },
            {
                action: "clickButton",
                element: "span",
                textContents: "claim",
                parentElement: "button",
                parentAttribute: "class",
                parentSelectorText: "Daily",
                duration: 8000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "daily",
                textContents: "rewards",
                duration: 8000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "daily",
                textContents: "spin",
                duration: 5000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "daily",
                textContents: "claim",
                duration: 7000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "daily",
                textContents: "claim",
                duration: 15000,
            },
            {
                action: "navigate",
                URL: "https://www.hellomillions.com/gold-coins",
                duration: 3000,
            },
            {
                action: "findVal",
                element: "span",
                slug: "HelloMillions",
                parentElement: "div",
                parentAttribute: "data-test",
                parentSelectorText: "sc-balance",
                duration: 7000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "daily",
            //   attribute: "id",
            //   element: "button",
            //   textContents: "claim",
            //   duration: 45000,
            // },
        ],
    },
    SpinBlitz: {
        email: [
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "header-login",
                duration: 5000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "xyzxyz",
                duration: 11000,
            },
            {
                action: "type",
                slug: "SpinBlitz",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "login-now",
                textContents: "log",
                duration: 7000,
            },
            {
                action: "navigate",
                URL: "https://www.spinblitz.com/gold-coins",
                duration: 6000,
            },
            {
                action: "clickButton",
                attribute: "class",
                element: "span",
                selectorText: "aily",
                textContents: "laim",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "ewards",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "ewards",
                duration: 17000,
            },
            {
                action: "navigate",
                URL: "https://www.spinblitz.com/",
            },
            {
                action: "findVal",
                element: "span",
                attribute: "data-test",
                selectorText: "sc-balance",
                slug: "SpinBlitz",
                duration: 5000,
            },
        ],
        google: [
            {
                action: "clickButton",
                element: "span",
                textContents: "google",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "UserKeys",
                accountId: "SportsMillions",
            },
            {
                action: "navigate",
                URL: "https://www.spinblitz.com/gold-coins",
                duration: 6000,
            },
            {
                action: "clickButton",
                attribute: "class",
                element: "span",
                selectorText: "aily",
                textContents: "laim",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "ewards",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "ewards",
                duration: 17000,
            },
            {
                action: "navigate",
                URL: "https://www.spinblitz.com/",
            },
            {
                action: "findVal",
                element: "span",
                attribute: "data-test",
                selectorText: "sc-balance",
                slug: "SpinBlitz",
                duration: 5000,
            },
        ],
    },
    DingDingDing: {
        email: [
            {
                action: "navigate",
                URL: "https://dingdingding.com/login/",
                duration: 4000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "xyzxyz",
                duration: 13000,
            },
            {
                action: "type",
                slug: "DingDingDing",
                userSelector: "input[type='email']",
                passSelector: "input[type='password']",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "strong",
                textContents: "log",
                duration: 7000,
            },
            {
                action: "clickButton",
                attribute: "class",
                element: "span",
                selectorText: "btn",
                textContents: "daily",
                duration: 18000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "collect",
                duration: 7000,
            },
            {
                action: "navigate",
                URL: "https://dingdingding.com/lobby/",
                duration: 4000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "id",
                selectorText: "switch",
                parentElement: "span",
                parentAttribute: "class",
                parentSelectorText: "counter",
                slug: "DingDingDing",
                duration: 5000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "daily",
            //   attribute: "id",
            //   element: "button",
            //   textContents: "claim",
            //   duration: 45000,
            // },
        ],
    },
    MegaBonanza: {
        email: [
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "header-login",
                duration: 5000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "xyzxyz",
                duration: 15000,
            },
            {
                action: "type",
                slug: "MegaBonanza",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "login-now",
                textContents: "log",
                duration: 7000,
            },
            {
                action: "navigate",
                URL: "https://www.megabonanza.com/gold-coins",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "claim",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "rewards",
                duration: 6000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "xyzxyz",
                duration: 18000,
            },
            {
                action: "navigate",
                URL: "https://www.megabonanza.com/gold-coins",
                duration: 2000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "class",
                selectorText: "currencyValue",
                slug: "MegaBonanza",
                duration: 5000,
            },
        ],
        google: [
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "header-login",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "google",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "UserKeys",
                accountId: "MegaBonanza",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "continue",
            },
            {
                action: "navigate",
                URL: "https://www.megabonanza.com/gold-coins",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "claim",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "rewards",
                duration: 6000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "xyzxyz",
                duration: 18000,
            },
            {
                action: "navigate",
                URL: "https://www.megabonanza.com/gold-coins",
                duration: 2000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "class",
                selectorText: "currencyValue",
                slug: "MegaBonanza",
                duration: 5000,
            },
        ],
    },
    BetCoin: {
        email: [
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "header-login",
                duration: 5000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "header-login",
                duration: 12000,
            },
            {
                action: "type",
                slug: "MegaBonanza",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "login-now",
                textContents: "log",
                duration: 7000,
            },
            {
                action: "navigate",
                URL: "https://www.mcluck.com/gold-coins",
                duration: 7000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "daily",
                textContents: "claim",
                duration: 5000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "daily",
                textContents: "rewards",
                duration: 6000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "data-test",
                selectorText: "sc-value",
                slug: "McLuck",
                duration: 18000,
            },
            {
                action: "navigate",
                URL: "https://www.mcluck.com",
                duration: 2000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "data-test",
                selectorText: "sc-value",
                slug: "MegaBonanza",
                duration: 5000,
            },
        ],
    },
    SidePot: {
        email: [
            {
                action: "clickButton",
                element: "button",
                textContents: "Log In",
                duration: 8000,
            },
            {
                action: "type",
                slug: "SidePot",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "button",
                attribute: "type",
                selectorText: "submit",
                textContents: "Log In",
                duration: 10000,
            },
            {
                action: "clickButton",
                attribute: "aria-label",
                element: "button",
                selectorText: "Bonuses",
                duration: 8000,
            },
            {
                action: "clickButton",
                attribute: "type",
                element: "button",
                selectorText: "button",
                textContents: "laim",
            },
            {
                action: "findVal",
                element: "span",
                attribute: "style",
                selectorText: "pointer-events",
                slug: "SidePot",
                duration: 8000,
            },
        ],
    },
    VegasCoins: {
        email: [
            {
                action: "clickButton",
                element: "span",
                textContents: "Log",
                duration: 8000,
            },
            {
                action: "type",
                slug: "VegasCoins",
                userSelector: "input[id='email']",
                passSelector: "input[id='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "Login",
                parentElement: "button",
                parentSelectorText: "submit",
                parentAttribute: "type",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "claim",
                duration: 8000,
            },
            {
                action: "findVal",
                element: "span",
                attribute: "class",
                selectorText: "text",
                parentElement: "div",
                parentSelectorText: "items",
                parentAttribute: "class",
                slug: "VegasCoins",
                duration: 8000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "daily",
            //   attribute: "id",
            //   element: "button",
            //   textContents: "claim",
            //   duration: 45000,
            // },
        ],
    },
    Dara: {
        email: [
            {
                action: "clickButton",
                element: "button",
                textContents: "Log In",
                duration: 8000,
            },
            {
                action: "type",
                slug: "Dara",
                userSelector: "input[type='id']",
                passSelector: "input[type='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "button",
                attribute: "class",
                selectorText: "login",
                duration: 10000,
            },
            {
                action: "clickButton",
                attribute: "class",
                element: "button",
                selectorText: "btn",
                textContents: "free",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "div",
                attribute: "class",
                selectorText: "btn",
                textContents: "collect",
            },
            {
                action: "clickButton",
                element: "svg",
                attribute: "data-icon",
                selectorText: "x",
            },
            {
                action: "clickButton",
                element: "img",
                attribute: "alt",
                selectorText: "SC",
            },
            {
                action: "findVal",
                element: "div",
                attribute: "class",
                selectorText: "coin",
                slug: "Dara",
                duration: 8000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "daily",
            //   attribute: "id",
            //   element: "button",
            //   textContents: "claim",
            //   duration: 45000,
            // },
        ],
    },
    CasinoClick: {
        email: [
            {
                action: "clickButton",
                element: "a",
                textContents: "Sign In",
                duration: 8000,
            },
            {
                action: "type",
                slug: "CasinoClick",
                userSelector: "input[name='clientIdentifier']",
                passSelector: "input[name='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "button",
                attribute: "type",
                selectorText: "submit",
                textContents: "sign in",
                duration: 10000,
            },
            {
                action: "clickButton",
                element: "a",
                textContents: "get coins",
                duration: 8000,
            },
            {
                action: "clickButton",
                attribute: "data-testid",
                element: "button",
                selectorText: "Bonus",
            },
            {
                action: "findVal",
                element: "p",
                attribute: "data-cp",
                selectorText: "Balance",
                slug: "CasinoClick",
                duration: 8000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "daily",
            //   attribute: "id",
            //   element: "button",
            //   textContents: "claim",
            //   duration: 45000,
            // },
            //ggXM@$Q8qbaDXhp
        ],
    },
    PlayFame: {
        email: [
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "header-login",
                duration: 5000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "xyzxyz",
                duration: 12000,
            },
            {
                action: "type",
                slug: "PlayFame",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "login-now",
                textContents: "log",
                duration: 7000,
            },
            {
                action: "navigate",
                URL: "https://www.PlayFame.com/gold-coins",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "claim",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "rewards",
                duration: 6000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "xyz",
                duration: 16000,
            },
            {
                action: "navigate",
                URL: "https://www.PlayFame.com/home",
                duration: 2000,
            },
            {
                action: "findVal",
                element: "span",
                parentElement: "div",
                parentSelectorText: "currency",
                parentAttribute: "class",
                slug: "PlayFame",
                duration: 6000,
            },
        ],
        google: [
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "header-login",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "google",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "UserKeys",
                accountId: "PlayFame",
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "UserKeys",
                accountId: "PlayFame",
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "login-now",
                textContents: "log",
                duration: 7000,
            },
            {
                action: "navigate",
                URL: "https://www.PlayFame.com/gold-coins",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "claim",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "rewards",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "xyz",
                duration: 16000,
            },
            {
                action: "navigate",
                URL: "https://www.PlayFame.com/home",
                duration: 2000,
            },
            {
                action: "findVal",
                element: "span",
                parentElement: "div",
                parentSelectorText: "currency",
                parentAttribute: "class",
                slug: "PlayFame",
                duration: 6000,
            },
        ],
    },
    Jackpota: {
        email: [
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "header-login",
                duration: 5000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "xyzxyz",
                duration: 12000,
            },
            {
                action: "type",
                slug: "Jackpota",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "login-now",
                textContents: "log",
                duration: 7000,
            },
            {
                action: "navigate",
                URL: "https://www.jackpota.com/gold-coins",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "claim",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "rewards",
                duration: 6000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "xyz",
                duration: 16000,
            },
            {
                action: "navigate",
                URL: "https://www.jackpota.com/home",
                duration: 2000,
            },
            {
                action: "findVal",
                element: "span",
                parentElement: "div",
                parentSelectorText: "currency",
                parentAttribute: "class",
                slug: "Jackpota",
                duration: 6000,
            },
        ],
        google: [
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "header-login",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "google",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "UserKeys",
                accountId: "Jackpota",
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "UserKeys",
                accountId: "Jackpota",
            },
            {
                action: "navigate",
                URL: "https://www.jackpota.com/gold-coins",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "claim",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "rewards",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "xyz",
                duration: 16000,
            },
            {
                action: "navigate",
                URL: "https://www.jackpota.com/home",
                duration: 2000,
            },
            {
                action: "findVal",
                element: "span",
                parentElement: "div",
                parentSelectorText: "currency",
                parentAttribute: "class",
                slug: "Jackpota",
                duration: 6000,
            },
        ],
    },
    SportsMillions: {
        email: [
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "header-login",
                textContents: "Log",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "xyz",
                selectorText: "xyzxyz",
                duration: 11000,
            },
            {
                action: "type",
                slug: "SportsMillions",
                userSelector: "input[name='email']",
                passSelector: "input[name='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                attribute: "data-test",
                element: "button",
                selectorText: "login-now",
                textContents: "log",
                duration: 7000,
            },
            {
                action: "navigate",
                URL: "https://www.SportsMillions.com/gold-coins",
                duration: 6000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "laim",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "eward",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "eward",
                duration: 17000,
            },
            {
                action: "navigate",
                URL: "https://www.SportsMillions.com/",
            },
            {
                action: "findVal",
                element: "span",
                parentElement: "div",
                parentSelectorText: "SC",
                parentAttribute: "data-title",
                slug: "SportsMillions",
                duration: 5000,
            },
        ],
        google: [
            {
                action: "clickButton",
                attribute: "data-test",
                element: "a",
                selectorText: "header-login",
                duration: 5000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "google",
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "UserKeys",
                accountId: "SportsMillions",
            },
            {
                action: "navigate",
                URL: "https://www.SportsMillions.com/gold-coins",
                duration: 6000,
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "laim",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "eward",
                duration: 7000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "eward",
                duration: 17000,
            },
            {
                action: "navigate",
                URL: "https://www.SportsMillions.com/",
            },
            {
                action: "findVal",
                element: "span",
                parentElement: "div",
                parentSelectorText: "SC",
                parentAttribute: "data-title",
                slug: "SportsMillions",
                duration: 5000,
            },
        ],
    },
    Baba: {
        email: [
            {
                action: "clickButton",
                element: "button",
                textContents: "log",
                duration: 8000,
            },
            {
                action: "type",
                slug: "Baba",
                userSelector: "input[type='email']",
                passSelector: "input[type='password']",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "login",
                duration: 10000,
            },
            {
                action: "clickButton",
                element: "button",
                textContents: "collect",
                duration: 8000,
            },
            {
                action: "clickButton",
                element: "div",
                textContents: "collect",
            },
            {
                action: "clickButton",
                element: "span",
                textContents: "collect",
            },
            {
                action: "findVal",
                element: "span",
                selectorText: "SC",
                slug: "Baba",
                duration: 8000,
            },
            // {
            //   action: "clickButton",
            //   selectorText: "daily",
            //   attribute: "id",
            //   element: "button",
            //   textContents: "claim",
            //   duration: 45000,
            // },
        ],
    },
};
/* harmony default export */ const accountActionSequence = ((/* unused pure expression or super */ null && (accountActionSequences)));

;// CONCATENATED MODULE: ./src/extension/badge/BadgeManager.ts
class BadgeManager {
    static async getStorageData(keys) {
        return chrome.storage.local.get(keys);
    }
    static async updateBadge() {
        try {
            const count = await this.countQualifyingAccounts();
            if (count === 0) {
                await chrome.action.setBadgeText({ text: "" });
                await chrome.action.setBadgeBackgroundColor({ color: [0, 0, 0, 0] });
            }
            else {
                await chrome.action.setBadgeText({ text: count.toString() });
                await chrome.action.setBadgeBackgroundColor({ color: "#FF8080" });
            }
        }
        catch (error) {
            console.error("Error updating badge:", error);
        }
    }
    static async countQualifyingAccounts() {
        try {
            // Get stored accounts first to ensure we only check valid accounts
            const result = await this.getStorageData("storedAccounts");
            const storedAccounts = result?.storedAccounts;
            if (!storedAccounts || Object.keys(storedAccounts).length === 0) {
                return 0;
            }
            const accountIds = Object.keys(storedAccounts);
            let count = 0;
            // Build keys to fetch all at once
            const keysToFetch = accountIds.reduce((acc, id) => {
                acc.push(`isActive_${id}`, `failCount_for_${id}`, `paused_${id}`, `status_${id}`, `collection_status_${id}`);
                return acc;
            }, []);
            // Fetch all account data in one call
            const accountData = await this.getStorageData(keysToFetch);
            // Count qualifying accounts
            for (const id of accountIds) {
                const isActive = accountData[`isActive_${id}`];
                const failCount = accountData[`failCount_for_${id}`] || 0;
                const isPaused = accountData[`paused_${id}`];
                // Account qualifies if:
                // 1. It is active
                // 2. Has failures OR is in a failed state OR collection failed
                // 3. Is not paused
                if (isActive && !isPaused && failCount > 0) {
                    count++;
                }
            }
            return count;
        }
        catch (error) {
            console.error("Error counting qualifying accounts:", error);
            return 0;
        }
    }
    static initialize() {
        // Listen for relevant storage changes
        chrome.storage.onChanged.addListener((changes, namespace) => {
            if (namespace !== "local")
                return;
            const shouldUpdate = Object.keys(changes).some((key) => key.startsWith("isActive_") ||
                key.startsWith("failCount_for_") ||
                key.startsWith("paused_") ||
                key.startsWith("status_") ||
                key.startsWith("collection_status_") ||
                key === "storedAccounts");
            if (shouldUpdate) {
                this.updateBadge();
            }
        });
    }
}

;// CONCATENATED MODULE: ./src/extension/alarm/StorageAlarmManager.ts
class StorageAlarmManager {
    constructor(registry) {
        this.registry = registry;
        this.initialized = false;
    }
    async initialize() {
        if (this.initialized) {
            console.log("⚠️ AlarmManager already initialized");
            return;
        }
        // try {
        //   // Set up hourly check alarm
        //   await chrome.alarms.create(StorageAlarmManager.ALARM_TYPES.HOURLY_CHECK, {
        //     periodInMinutes: 30,
        //   });
        //   // Initial alarm check
        //   await this.checkAndSetAlarmsForAllAccounts();
        //   this.initialized = true;
        //   console.log("✅ Alarm Manager initialized");
        // } catch (error) {
        //   console.error("❌ Failed to initialize AlarmManager:", error);
        //   throw error;
        // }
    }
    async handleValueUpdate(accountId, newValue) {
        console.log(`💾 Handling value update for ${accountId}:`, {
            newValue,
            timestamp: new Date().toISOString(),
        });
        try {
            const exemptAccounts = ["Sweep", "Crown", "Zoot"];
            const isExempt = exemptAccounts.includes(accountId);
            const { currentValue, storedAccounts, failCount } = await this.getCurrentAccountState(accountId);
            // Case 1: Exempt accounts - always update
            if (isExempt) {
                console.log(`✅ Updating exempt account ${accountId}`);
                await this.updateStorageValues(accountId, newValue, storedAccounts);
                return true;
            }
            // Case 2: Error case - null, 0, or unchanged value
            if (newValue === null || newValue === 0 || newValue === currentValue) {
                console.log(`❌ Error case for ${accountId} - invalid or unchanged value:`, {
                    newValue,
                    currentValue,
                    currentFailCount: failCount,
                });
                return false;
            }
            // Case 3: Success case - valid new value
            console.log(`✅ Valid value update for ${accountId}: ${currentValue} -> ${newValue}`);
            await this.updateStorageValues(accountId, newValue, storedAccounts);
            // Reset fail count on success
            await chrome.storage.local.set({ [`failCount_for_${accountId}`]: 0 });
            return true;
        }
        catch (error) {
            console.error(`❌ Error updating value for ${accountId}:`, error);
            return false;
        }
    }
    async getCurrentAccountState(accountId) {
        const data = await chrome.storage.local.get([
            `value_for_${accountId}`,
            `failCount_for_${accountId}`,
            "storedAccounts",
        ]);
        return {
            currentValue: data[`value_for_${accountId}`],
            failCount: data[`failCount_for_${accountId}`] || 0,
            storedAccounts: data.storedAccounts || {},
        };
    }
    async updateStorageValues(accountId, newValue, storedAccounts) {
        const timestamp = new Date().toISOString();
        const updates = {
            [`value_for_${accountId}`]: newValue,
            [`timestamp_for_${accountId}`]: timestamp,
        };
        storedAccounts[accountId] = {
            ...(storedAccounts[accountId] || {}),
            currentVal: newValue,
            timestamp,
        };
        await Promise.all([
            chrome.storage.local.set(updates),
            chrome.storage.local.set({ storedAccounts }),
        ]);
    }
    async checkAndSetAlarmsForAllAccounts() {
        try {
            const { storedAccounts = {} } = await chrome.storage.local.get("storedAccounts");
            for (const [accountId] of Object.entries(storedAccounts)) {
                await this.checkAndSetAlarmForAccount(accountId);
            }
        }
        catch (error) {
            console.error("❌ Failed to check alarms:", error);
        }
    }
    async handleResolveAlarm() {
        try {
            console.log("🔄 Starting resolve alarm handler");
            const { storedAccounts = {} } = await chrome.storage.local.get("storedAccounts");
            // First, gather all accounts that need resolving
            const accountsToResolve = [];
            for (const [accountId, account] of Object.entries(storedAccounts)) {
                const status = await this.fetchAccountStatus(accountId);
                const collectionStatus = status[`collection_status_${accountId}`];
                const failCount = status[`failCount_for_${accountId}`] || 0;
                if (collectionStatus === "waitingforresolve" || failCount > 1) {
                    console.log(`Found account to resolve: ${accountId}`, {
                        status: collectionStatus,
                        failCount,
                    });
                    accountsToResolve.push({ accountId, account });
                }
            }
            // Process accounts
            for (const { accountId, account } of accountsToResolve) {
                const status = await this.fetchAccountStatus(accountId);
                if (!status[`isActive_${accountId}`] ||
                    status[`collection_status_${accountId}`] === "collecting" ||
                    status[`collection_status_${accountId}`] === "queued") {
                    console.log(`⏭️ [Resolve] Skipping resolve for ${accountId} - Invalid state`);
                    continue;
                }
                // Clear locks
                await chrome.storage.local.remove([
                    `collection_lock_${accountId}`,
                    `manualAlarmSet_${accountId}`,
                ]);
                // Use the registry's queue manager directly
                try {
                    const success = await this.registry.backgroundQueueManager.addToQueue(accountId, account.URL);
                    if (success) {
                        console.log(`✅ [Resolve] Added ${accountId} to queue`);
                    }
                    else {
                        console.error(`❌ [Resolve] Failed to add ${accountId} to queue`);
                    }
                }
                catch (error) {
                    console.error(`❌ [Resolve] Error adding ${accountId} to queue:`, error);
                }
            }
            console.log(`✅ Resolve alarm handler completed. Processed ${accountsToResolve.length} accounts.`);
        }
        catch (error) {
            console.error("❌ Error in handleResolveAlarm:", error);
        }
    }
    // Helper methods
    static getRetryDelay(failCount) {
        const baseDelay = StorageAlarmManager.BASE_RETRY_DELAY * 60 * 1000;
        const maxDelay = StorageAlarmManager.MAX_RETRY_DELAY * 60 * 1000;
        const exponentialDelay = baseDelay * Math.pow(2, failCount - 1);
        const jitter = (Math.random() - 0.5) * 60 * 1000;
        return Math.min(exponentialDelay + jitter, maxDelay);
    }
    static getRandomDelay() {
        const minutes = Math.floor(Math.random() *
            (StorageAlarmManager.RANDOM_DELAY_MAX -
                StorageAlarmManager.RANDOM_DELAY_MIN +
                1) +
            StorageAlarmManager.RANDOM_DELAY_MIN);
        return minutes * 60 * 1000;
    }
    static calculateNextTriggerTime(timestamp, waitPeriod) {
        if (!timestamp || !waitPeriod)
            return null;
        const baseDelay = waitPeriod * 60 * 60 * 1000;
        const lastTimestamp = new Date(timestamp).getTime();
        if (isNaN(lastTimestamp))
            return null;
        return lastTimestamp + baseDelay;
    }
    static determineAlarmCase(alarmDetails, failCount, nextTriggerTime, timestamp = null) {
        // ALWAYS check fail count first
        if (failCount > 0) {
            console.log("🔄 Retry case detected - failCount:", failCount);
            return alarmDetails ? "UPDATE_RETRY" : "NEW_RETRY";
        }
        // If we have a timestamp but no alarm, we MUST create one
        if (!alarmDetails && timestamp !== null) {
            console.log("⏰ Successful collection exists but no alarm - creating new regular alarm");
            return "NEW_REGULAR";
        }
        // For existing alarms, check if they're in acceptable range
        if (alarmDetails) {
            return StorageAlarmManager.isAlarmInAcceptableRange(alarmDetails, nextTriggerTime)
                ? "KEEP_EXISTING"
                : "UPDATE_REGULAR";
        }
        // No timestamp and no alarm - create new
        return "NEW_REGULAR";
    }
    static isAlarmInAcceptableRange(existingAlarm, nextTriggerTime) {
        const difference = Math.abs(existingAlarm.scheduledTime - nextTriggerTime);
        const differenceMinutes = difference / (60 * 1000);
        return differenceMinutes <= 20;
    }
    async setCollectionAlarm(accountId, when, isRetry = false) {
        const alarmName = `${StorageAlarmManager.ALARM_TYPES.COLLECTION}${accountId}`;
        await chrome.alarms.clear(alarmName);
        await chrome.alarms.create(alarmName, { when });
        console.log(`⏰ [Alarm] Set ${isRetry ? "retry" : "regular"} alarm for ${accountId} at ${new Date(when).toISOString()}`);
    }
    async fetchAccountStatus(accountId) {
        return await chrome.storage.local.get([
            `collection_status_${accountId}`,
            `failCount_for_${accountId}`,
            `timestamp_for_${accountId}`,
            `waitPeriod_for_${accountId}`,
            `isActive_${accountId}`,
            `paused_${accountId}`,
            `manualAlarmSet_${accountId}`,
        ]);
    }
    async shouldSkipAccount(accountId, status) {
        const failCount = status[`failCount_for_${accountId}`] || 0;
        const isManualAlarmSet = status[`manualAlarmSet_${accountId}`] || false;
        const collectionStatus = status[`collection_status_${accountId}`];
        const isActive = status[`isActive_${accountId}`];
        const isPaused = status[`paused_${accountId}`];
        const timestamp = status[`timestamp_for_${accountId}`] || null;
        const waitPeriod = status[`waitPeriod_for_${accountId}`] || 24;
        if (!isActive) {
            // console.log(`⏭️ [Alarm] Skipping ${accountId} - Account not active`);
            return true;
        }
        if (isPaused) {
            // console.log(`⏭️ [Alarm] Skipping ${accountId} - Account is paused`);
            return true;
        }
        if (collectionStatus === "collecting" ||
            collectionStatus === "queued" ||
            collectionStatus === "waitingforresolve") {
            console.log(`⏭️ [Alarm] Skipping ${accountId} - Collection in progress (status: ${collectionStatus})`);
            return true;
        }
        if (failCount > 5) {
            console.log(`⏭️ [Alarm] Skipping ${accountId} - Too many failures (count: ${failCount})`);
            return true;
        }
        if (timestamp) {
            const timeSinceLastCollection = Date.now() - new Date(timestamp).getTime();
            const waitPeriodMs = waitPeriod * 60 * 60 * 1000;
            if (timeSinceLastCollection < waitPeriodMs) {
                await chrome.storage.local.set({ [`failCount_for_${accountId}`]: 0 });
            }
        }
        if (isManualAlarmSet) {
            console.log(`⏭️ [Alarm] Skipping ${accountId} - Manual alarm is set`);
            return true;
        }
        console.log(`✅ [Alarm] ${accountId} passed all skip checks`);
        return false;
    }
    async checkAndSetAlarmForAccount(accountId) {
        try {
            // console.log(`🔄 Starting alarm check for ${accountId}`);
            const status = await this.fetchAccountStatus(accountId);
            // console.log(`📊 Current status for ${accountId}:`, status);
            if (await this.shouldSkipAccount(accountId, status)) {
                // console.log(
                //   `⏭️ Skipping alarm check for ${accountId} - shouldSkipAccount returned true`
                // );
                return;
            }
            const timestamp = status[`timestamp_for_${accountId}`] || null;
            const waitPeriod = status[`waitPeriod_for_${accountId}`] || 24;
            const failCount = status[`failCount_for_${accountId}`] || 0;
            // console.log(`📊 Checking alarm with params:`, {
            //   accountId,
            //   timestamp,
            //   waitPeriod,
            //   failCount,
            // });
            // Calculate next trigger time
            const nextTriggerTime = StorageAlarmManager.calculateNextTriggerTime(timestamp, waitPeriod);
            if (!nextTriggerTime) {
                console.error("❌ Failed to calculate next trigger time for account:", accountId);
                return;
            }
            // Get existing alarm if any
            const alarmName = `${StorageAlarmManager.ALARM_TYPES.COLLECTION}${accountId}`;
            const existingAlarm = await chrome.alarms.get(alarmName);
            const alarmDetails = existingAlarm
                ? { scheduledTime: existingAlarm.scheduledTime }
                : null;
            // Determine what action to take
            const alarmCase = StorageAlarmManager.determineAlarmCase(alarmDetails, failCount, nextTriggerTime, timestamp);
            // console.log(`🔍 [Alarm] Determined case for ${accountId}:`, {
            //   alarmCase,
            //   failCount,
            //   timestamp,
            //   nextTriggerTime: new Date(nextTriggerTime).toISOString(),
            //   existingAlarm: existingAlarm
            //     ? new Date(existingAlarm.scheduledTime).toISOString()
            //     : null,
            // });
            switch (alarmCase) {
                case "NEW_RETRY":
                case "UPDATE_RETRY":
                    await this.setCollectionAlarm(accountId, Date.now() + StorageAlarmManager.getRetryDelay(failCount), true);
                    break;
                case "NEW_REGULAR":
                case "UPDATE_REGULAR":
                    await this.setCollectionAlarm(accountId, nextTriggerTime + StorageAlarmManager.getRandomDelay(), false);
                    break;
                case "KEEP_EXISTING":
                    // console.log(`✅ [Alarm] Keeping existing alarm for ${accountId}`);
                    break;
                default:
                    console.warn("⚠️ Unknown alarm case:", alarmCase);
            }
        }
        catch (error) {
            console.error(`❌ Failed to check alarm for ${accountId}:`, error);
            throw error; // Re-throw to be caught by caller
        }
    }
}
StorageAlarmManager.ALARM_TYPES = {
    COLLECTION: "collectAlarm_",
    HOURLY_CHECK: "hourly_check",
    RESOLVE: "resolve_alarm",
    KEEPALIVE: "keepalive",
};
// Delay constants
StorageAlarmManager.RANDOM_DELAY_MIN = 7; // Minimum random delay in minutes
StorageAlarmManager.RANDOM_DELAY_MAX = 17; // Maximum random delay in minutes
StorageAlarmManager.BASE_RETRY_DELAY = 12; // Base retry delay in minutes
StorageAlarmManager.MAX_RETRY_DELAY = 240; // Maximum retry delay in minutes

;// CONCATENATED MODULE: ./src/extension/alarm/balanceLogger.ts
class BalanceLogger {
    static async logAllAccountBalances() {
        try {
            const { storedAccounts = {}, lastBalanceLog } = (await chrome.storage.local.get([
                "storedAccounts",
                "lastBalanceLog",
            ]));
            // If we have a lastBalanceLog, check if enough time has passed
            if (lastBalanceLog) {
                const now = new Date();
                const lastLog = new Date(lastBalanceLog);
                const timeSinceLastLog = now.getTime() - lastLog.getTime();
                const waitPeriodMs = 24 * 60 * 60 * 1000; // 24 hours in milliseconds
                if (timeSinceLastLog < waitPeriodMs) {
                    console.log("⏭️ Skipping balance log - Not enough time has passed");
                    return;
                }
            }
            // If we get here, either no lastBalanceLog exists or enough time has passed
            const now = new Date();
            for (const [accountId, account] of Object.entries(storedAccounts)) {
                try {
                    // Check if account is active
                    const { [`isActive_${accountId}`]: isActive } = await chrome.storage.local.get(`isActive_${accountId}`);
                    // Skip if account is not active
                    if (!isActive) {
                        console.log(`⏭️ Skipping balance log for inactive account: ${accountId}`);
                        continue;
                    }
                    const balance = account?.currentVal || 0;
                    const balanceEntry = {
                        date: now.toISOString(),
                        balance,
                    };
                    console.log(`📝 Logging balance for active account: ${accountId}`);
                    const { [`balanceHistory_${accountId}`]: history = [] } = await chrome.storage.local.get(`balanceHistory_${accountId}`);
                    history.push(balanceEntry);
                    await chrome.storage.local.set({
                        [`balanceHistory_${accountId}`]: history,
                    });
                }
                catch (error) {
                    console.error(`❌ Error logging balance for account ${accountId}:`, error);
                    continue;
                }
            }
            // Update last balance log timestamp
            await chrome.storage.local.set({ lastBalanceLog: now.toISOString() });
            console.log("✅ Completed logging balances for active accounts");
        }
        catch (error) {
            console.error("❌ Error in logAllAccountBalances:", error);
        }
    }
}
/* harmony default export */ const balanceLogger = (BalanceLogger);

;// CONCATENATED MODULE: ./src/extension/background.ts




// System managers with singleton pattern and lazy initialization
class ManagerRegistry {
    constructor() {
        this._alarmManager = null;
        this._backgroundQueueManager = null;
        this._collectionManager = null;
        this._badgeManager = null;
        this.initializationPromise = null;
    }
    static getInstance() {
        if (!ManagerRegistry.instance) {
            ManagerRegistry.instance = new ManagerRegistry();
        }
        return ManagerRegistry.instance;
    }
    async initialize(forceInit = false) {
        if (this.initializationPromise) {
            return this.initializationPromise;
        }
        this.initializationPromise = this._initialize(forceInit);
        return this.initializationPromise;
    }
    async _initialize(forceInit) {
        try {
            // Always initialize badge manager first for real-time updates
            if (!this._badgeManager || forceInit) {
                await this.initializeBadgeManager();
                //console.log("Hey Bwennin!");
            }
            // Initialize other managers
            if (!this._alarmManager || forceInit) {
                this._alarmManager = new StorageAlarmManager(this);
                await this._alarmManager.initialize();
            }
            if (!this._backgroundQueueManager || forceInit) {
                this._backgroundQueueManager = new BackgroundQueueManager(this);
            }
            if (forceInit) {
                await this.cleanupStaleStates();
                await this._alarmManager.checkAndSetAlarmsForAllAccounts();
                await this.setupKeepAlive();
            }
            // Always update badge
            await BadgeManager.updateBadge();
        }
        catch (error) {
            console.error("❌ Error in manager initialization:", error);
            this.initializationPromise = null;
            throw error;
        }
    }
    async cleanupStaleStates() {
        try {
            const { storedAccounts = {} } = await chrome.storage.local.get("storedAccounts");
            // Batch all storage operations
            const updates = {};
            const keysToRemove = [];
            // Prepare updates for non-idle states
            for (const accountId of Object.keys(storedAccounts)) {
                const { [`collection_status_${accountId}`]: status } = await chrome.storage.local.get(`collection_status_${accountId}`);
                if (status && status !== "idle") {
                    updates[`collection_status_${accountId}`] = "idle";
                }
            }
            // Get all lock keys in one operation
            const allStorage = await chrome.storage.local.get(null);
            const lockKeys = Object.keys(allStorage).filter((key) => key.startsWith("collection_lock_") || key === "queue_processing_lock");
            keysToRemove.push(...lockKeys);
            // Execute all storage operations in parallel
            await Promise.all([
                chrome.storage.local.set(updates),
                chrome.storage.local.remove(keysToRemove),
                chrome.storage.local.remove("collection_queue"),
            ]);
        }
        catch (error) {
            console.error("❌ Error cleaning up stale states:", error);
        }
    }
    async setupKeepAlive() {
        try {
            await Promise.all([
                chrome.alarms.clear("systemCheck"),
                chrome.alarms.clear("balanceLogger"),
                chrome.alarms.clear("queueHealthCheck"),
                this.initializeBadgeManager(),
                this.setupSystemCheck(),
                this.setupBalanceLogger(),
                this.setupQueueHealthCheck(),
                this.verifyAlarms(),
            ]);
        }
        catch (error) {
            console.error("❌ Error in setupKeepAlive:", error);
        }
    }
    async initializeBadgeManager() {
        if (!this._badgeManager) {
            await BadgeManager.initialize();
            await BadgeManager.updateBadge();
            this._badgeManager = BadgeManager;
        }
    }
    async setupSystemCheck() {
        await chrome.alarms.create("systemCheck", {
            periodInMinutes: 2,
            when: Date.now() + 1000,
        });
    }
    async setupBalanceLogger() {
        // Run balance logger every hour
        await chrome.alarms.create("balanceLogger", {
            periodInMinutes: 60,
            when: Date.now() + 1000,
        });
    }
    async setupQueueHealthCheck() {
        await chrome.alarms.create("queueHealthCheck", {
            periodInMinutes: 5, // Run every 5 minutes
            when: Date.now() + 1000,
        });
    }
    async verifyAlarms() {
        const [alarms, { storedAccounts = {} }, { resolveTimes = [] }] = await Promise.all([
            chrome.alarms.getAll(),
            chrome.storage.local.get("storedAccounts"),
            chrome.storage.local.get("resolveTimes"),
        ]);
        const alarmNames = new Set(alarms.map((a) => a.name));
        // Handle collection alarms
        const collectionPromises = Object.keys(storedAccounts)
            .filter((accountId) => !alarmNames.has(`collectAlarm_${accountId}`))
            .map((accountId) => this._alarmManager?.checkAndSetAlarmForAccount(accountId));
        // Handle resolve alarms
        const resolvePromises = resolveTimes
            .filter((time) => time && !alarmNames.has(`resolve_alarm_${time}`))
            .map((time) => this.createResolveAlarm(time));
        await Promise.all([...collectionPromises, ...resolvePromises]);
    }
    async createResolveAlarm(time) {
        const [hours, minutes] = time.split(":").map(Number);
        const scheduledTime = new Date();
        scheduledTime.setHours(hours, minutes, 0, 0);
        if (scheduledTime.getTime() <= Date.now()) {
            scheduledTime.setDate(scheduledTime.getDate() + 1);
        }
        await chrome.alarms.create(`resolve_alarm_${time}`, {
            when: scheduledTime.getTime(),
            periodInMinutes: 24 * 60,
        });
    }
    // Getters with lazy initialization
    get alarmManager() {
        if (!this._alarmManager) {
            throw new Error("AlarmManager not initialized");
        }
        return this._alarmManager;
    }
    get backgroundQueueManager() {
        if (!this._backgroundQueueManager) {
            this._backgroundQueueManager = new BackgroundQueueManager(this);
        }
        return this._backgroundQueueManager;
    }
    get collectionManager() {
        if (!this._collectionManager) {
            this._collectionManager = new CollectionManager();
        }
        return this._collectionManager;
    }
}
// Replace global managers with registry
const managerRegistry = ManagerRegistry.getInstance();
// Update message listener
chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
    (async () => {
        try {
            // Always ensure system is initialized first
            await managerRegistry.initialize();
            const messageType = message.type || message.action;
            console.log(`📨 Message received: ${messageType}`, message);
            switch (messageType) {
                case "ACTION_STATUS": {
                    // Handle action status updates from content script
                    if (sender.tab?.id) {
                        console.log(`✅ Action status update from tab ${sender.tab.id}:`, message);
                        // No need to send response for status updates
                    }
                    break;
                }
                case "PERFORM_COLLECTION": {
                    if (!message.data?.accountId || !message.data?.URL) {
                        throw new Error("Missing required parameters for collection");
                    }
                    try {
                        await managerRegistry.collectionManager.performCollection(message.data.accountId, message.data.URL);
                        console.log("✅ Collection completed for", message.data.accountId);
                        sendResponse({ success: true });
                    }
                    catch (error) {
                        console.error("❌ Collection error:", error);
                        sendResponse({ success: false, error: String(error) });
                    }
                    break;
                }
                case "UPDATE_VALUE": {
                    if (!message.accountId || message.value === undefined) {
                        throw new Error("Missing required parameters for UPDATE_VALUE");
                    }
                    try {
                        await managerRegistry.alarmManager.handleValueUpdate(message.accountId, message.value);
                        sendResponse({ success: true });
                    }
                    catch (error) {
                        console.error("❌ Value update error:", error);
                        sendResponse({ success: false, error: String(error) });
                    }
                    break;
                }
                case "QUEUE_ADD": {
                    const queueData = message.data || {
                        accountId: message.accountId,
                        URL: message.URL,
                    };
                    if (!queueData.accountId || !queueData.URL) {
                        sendResponse({
                            success: false,
                            error: "Missing required parameters",
                        });
                        return;
                    }
                    try {
                        const success = await managerRegistry.backgroundQueueManager.addToQueue(queueData.accountId, queueData.URL);
                        console.log(`Queue result: ${success ? "✅ Success" : "❌ Failed"}`);
                        sendResponse({ success });
                    }
                    catch (error) {
                        console.error("❌ Queue error:", error);
                        sendResponse({ success: false, error: String(error) });
                    }
                    break;
                }
                case "CREATE_RESOLVE_ALARMS": {
                    if (!message.data?.times) {
                        sendResponse({ success: false, error: "Missing times array" });
                        return;
                    }
                    try {
                        // Clear existing resolve alarms
                        const alarms = await chrome.alarms.getAll();
                        await Promise.all(alarms
                            .filter((alarm) => alarm.name.startsWith("resolve_alarm_"))
                            .map((alarm) => chrome.alarms.clear(alarm.name)));
                        // Create new alarms in parallel
                        await Promise.all(message.data.times.filter(Boolean).map(async (time) => {
                            const [hours, minutes] = time.split(":").map(Number);
                            const scheduledTime = new Date();
                            scheduledTime.setHours(hours, minutes, 0, 0);
                            if (scheduledTime.getTime() <= Date.now()) {
                                scheduledTime.setDate(scheduledTime.getDate() + 1);
                            }
                            const alarmName = `resolve_alarm_${time}`;
                            await chrome.alarms.create(alarmName, {
                                when: scheduledTime.getTime(),
                                periodInMinutes: 24 * 60,
                            });
                            console.log(`✅ Created resolve alarm: ${alarmName} at ${scheduledTime.toISOString()}`);
                        }));
                        sendResponse({ success: true });
                    }
                    catch (error) {
                        console.error("❌ Error creating resolve alarms:", error);
                        sendResponse({ success: false, error: String(error) });
                    }
                    break;
                }
                case "SWITCH_TAB": {
                    try {
                        const result = await managerRegistry.collectionManager.handleTabSwitch(message.urlPattern);
                        sendResponse(result);
                    }
                    catch (error) {
                        console.error("❌ Tab switch error:", error);
                        sendResponse({ success: false, error: String(error) });
                    }
                    break;
                }
                default:
                    console.log("⚠️ Unknown message type:", messageType);
                    sendResponse({ success: false, error: "Unknown message type" });
            }
        }
        catch (error) {
            console.error("❌ Error processing message:", error);
            sendResponse({ success: false, error: String(error) });
        }
    })();
    // Keep message channel open for async response
    return true;
});
// Update alarm listener
chrome.alarms.onAlarm.addListener(async (alarm) => {
    if (!alarm?.name)
        return;
    try {
        // Ensure system is initialized
        await managerRegistry.initialize();
        // Handle different alarm types
        if (alarm.name.startsWith("collectAlarm_")) {
            const accountId = alarm.name.replace("collectAlarm_", "");
            const { storedAccounts = {} } = await chrome.storage.local.get("storedAccounts");
            const account = storedAccounts[accountId];
            if (account) {
                await managerRegistry.backgroundQueueManager.addToQueue(accountId, account.URL);
            }
        }
        else if (alarm.name.startsWith("resolve_alarm_")) {
            await managerRegistry.alarmManager.handleResolveAlarm();
        }
        else if (alarm.name === "systemCheck") {
            await managerRegistry.initialize(true);
        }
        else if (alarm.name === "balanceLogger") {
            await balanceLogger.logAllAccountBalances();
        }
        else if (alarm.name === "disableActiveTabsToggle") {
            await chrome.storage.local.set({ activeTabsToggle: false });
            await managerRegistry.backgroundQueueManager.transferWaitingForResolveToQueue();
        }
        else if (alarm.name === "queueHealthCheck") {
            await managerRegistry.backgroundQueueManager.checkQueueHealth();
        }
    }
    catch (error) {
        console.error("❌ Error handling alarm:", error);
    }
});
// Update startup listeners
chrome.runtime.onStartup.addListener(async () => {
    await managerRegistry.initialize(true);
});
chrome.runtime.onInstalled.addListener((details) => {
    if (details.reason === "install" || details.reason === "update") {
        managerRegistry.initialize(true);
    }
});
class BackgroundQueueManager {
    constructor(registry) {
        this.registry = registry;
        this.queue = [];
        this.processingAccounts = new Set();
        this.processingTimeout = null;
        this.MAX_RETRIES = 2;
        this.MAX_CONCURRENT_COLLECTIONS = 1; // Changed to 1 since we're using active tabs
        this.QUEUE_PROCESS_DELAY = 2000;
    }
    isAccountInQueue(accountId) {
        return this.queue.some((item) => item.accountId === accountId);
    }
    async addToQueue(accountId, URL) {
        try {
            // Check if account is already in queue or processing
            if (this.isAccountInQueue(accountId) ||
                this.processingAccounts.has(accountId)) {
                return false;
            }
            // Check activeTabsToggle status
            const { activeTabsToggle } = await chrome.storage.local.get("activeTabsToggle");
            if (activeTabsToggle) {
                // Special path for activeTabsToggle - just set status and don't add to processing queue
                await chrome.storage.local.set({
                    [`collection_status_${accountId}`]: "waitingforresolve",
                });
                console.log(`Added ${accountId} to waiting for resolve queue - Active Tabs Toggle is on`);
                return true;
            }
            // Normal queue path
            await chrome.storage.local.set({
                [`collection_status_${accountId}`]: "queued",
            });
            this.queue.push({
                accountId,
                URL,
                timestamp: Date.now(),
                retryCount: 0,
            });
            // Debounced queue processing
            if (this.processingTimeout) {
                clearTimeout(this.processingTimeout);
            }
            this.processingTimeout = setTimeout(() => this.processQueue(), this.QUEUE_PROCESS_DELAY);
            return true;
        }
        catch (error) {
            console.error("❌ Error adding to queue:", error);
            return false;
        }
    }
    async processQueue() {
        if (this.queue.length === 0) {
            return;
        }
        try {
            // Process one item at a time since we're using active tabs
            if (this.processingAccounts.size >= this.MAX_CONCURRENT_COLLECTIONS) {
                return;
            }
            // Take the first item in queue (FIFO)
            const item = this.queue[0];
            if (!this.processingAccounts.has(item.accountId)) {
                this.processingAccounts.add(item.accountId);
                await this.startCollection(item);
            }
        }
        catch (error) {
            console.error("❌ Error processing queue:", error);
        }
    }
    async startCollection(item) {
        try {
            // Initialize collection manager through registry
            const collectionManager = this.registry.collectionManager;
            // Update status and remove from queue atomically
            await Promise.all([
                chrome.storage.local.set({
                    [`collection_status_${item.accountId}`]: "collecting",
                }),
                Promise.resolve().then(() => {
                    this.queue = this.queue.filter((queueItem) => queueItem.accountId !== item.accountId);
                }),
            ]);
            // Perform collection
            const success = await collectionManager.performCollection(item.accountId, item.URL);
            // Handle collection result
            if (!success && (item.retryCount || 0) < this.MAX_RETRIES) {
                // Re-queue with incremented retry count
                this.queue.push({
                    ...item,
                    retryCount: (item.retryCount || 0) + 1,
                    timestamp: Date.now(),
                });
            }
            else {
                await this.completeCollection(item.accountId);
            }
        }
        catch (error) {
            await this.completeCollection(item.accountId);
        }
    }
    async completeCollection(accountId) {
        try {
            // Get all required data in parallel
            const [timestamp, waitPeriod, currentFailCount] = await Promise.all([
                chrome.storage.local.get(`timestamp_for_${accountId}`),
                chrome.storage.local.get(`waitPeriod_for_${accountId}`),
                chrome.storage.local.get(`failCount_for_${accountId}`),
            ]);
            const timeSinceLastCollection = timestamp[`timestamp_for_${accountId}`]
                ? Date.now() -
                    new Date(timestamp[`timestamp_for_${accountId}`]).getTime()
                : Infinity;
            const waitPeriodMs = (waitPeriod[`waitPeriod_for_${accountId}`] || 24) * 60 * 60 * 1000;
            // Update storage in parallel
            await Promise.all([
                chrome.storage.local.set({
                    [`collection_status_${accountId}`]: "idle",
                    [`failCount_for_${accountId}`]: timeSinceLastCollection < waitPeriodMs
                        ? 0
                        : (currentFailCount[`failCount_for_${accountId}`] || 0) + 1,
                    [`manualAlarmSet_${accountId}`]: false,
                }),
                this.registry.alarmManager.checkAndSetAlarmForAccount(accountId),
            ]);
            // Cleanup and process next
            this.processingAccounts.delete(accountId);
            this.processQueue();
        }
        catch (error) {
            console.error(`❌ Error in completeCollection for ${accountId}:`, error);
            this.processingAccounts.delete(accountId);
            this.processQueue();
        }
    }
    async checkQueueHealth() {
        try {
            // First check activeTabsToggle and waitingforresolve items
            const { activeTabsToggle } = await chrome.storage.local.get("activeTabsToggle");
            if (!activeTabsToggle) {
                // If toggle is off, check for any stuck items in waitingforresolve
                const allStorage = await chrome.storage.local.get(null);
                let hasWaitingItems = false;
                for (const [key, value] of Object.entries(allStorage)) {
                    if (key.startsWith("collection_status_") &&
                        value === "waitingforresolve") {
                        hasWaitingItems = true;
                        break;
                    }
                }
                if (hasWaitingItems) {
                    console.log("🔄 Found waiting items while toggle is off - transferring to main queue");
                    await this.transferWaitingForResolveToQueue();
                }
            }
            // Define what's considered "stuck" - 10 minutes
            const currentTime = Date.now();
            const stuckTimeout = 10 * 60 * 1000; // 10 minutes
            // Check processing accounts
            for (const accountId of this.processingAccounts) {
                const { [`collection_status_${accountId}`]: status } = await chrome.storage.local.get(`collection_status_${accountId}`);
                // Look for accounts stuck in "collecting" state
                if (status === "collecting") {
                    const item = this.queue.find((i) => i.accountId === accountId);
                    if (item && currentTime - item.timestamp > stuckTimeout) {
                        // If item has been "collecting" for more than 10 minutes:
                        console.log(`🔄 Resetting stuck collection for ${accountId}`);
                        this.processingAccounts.delete(accountId);
                        await chrome.storage.local.set({
                            [`collection_status_${accountId}`]: "idle",
                        });
                    }
                }
            }
            // Check if queue is stuck
            if (this.queue.length > 0 && this.processingAccounts.size === 0) {
                // If there are items in queue but nothing processing:
                console.log("🔄 Restarting stuck queue processing");
                this.processQueue();
            }
        }
        catch (error) {
            console.error("❌ Error in queue health check:", error);
        }
    }
    async transferWaitingForResolveToQueue() {
        try {
            // Get all accounts in waitingforresolve status
            const allStorage = await chrome.storage.local.get(null);
            const accountsToTransfer = [];
            // Find all accounts in waitingforresolve status
            for (const [key, value] of Object.entries(allStorage)) {
                if (key.startsWith("collection_status_") &&
                    value === "waitingforresolve") {
                    const accountId = key.replace("collection_status_", "");
                    const { storedAccounts = {} } = await chrome.storage.local.get("storedAccounts");
                    const account = storedAccounts[accountId];
                    if (account) {
                        accountsToTransfer.push({
                            accountId,
                            URL: account.URL,
                        });
                    }
                }
            }
            // Transfer accounts to main queue
            console.log(`🔄 Transferring ${accountsToTransfer.length} accounts from waiting to main queue`);
            for (const account of accountsToTransfer) {
                await chrome.storage.local.set({
                    [`collection_status_${account.accountId}`]: "queued",
                });
                this.queue.push({
                    accountId: account.accountId,
                    URL: account.URL,
                    timestamp: Date.now(),
                    retryCount: 0,
                });
            }
            // Start processing if there are transferred items
            if (accountsToTransfer.length > 0) {
                if (this.processingTimeout) {
                    clearTimeout(this.processingTimeout);
                }
                this.processingTimeout = setTimeout(() => this.processQueue(), this.QUEUE_PROCESS_DELAY);
            }
        }
        catch (error) {
            console.error("❌ Error transferring waiting queue:", error);
        }
    }
}
class CollectionManager {
    constructor() {
        this.originalTabId = null;
        this.currentTabId = null;
        this.handleTabRemoval = async (tabId) => {
            if (tabId === this.currentTabId) {
                // Target tab was closed, switch back to original tab if it exists
                if (this.originalTabId) {
                    try {
                        await chrome.tabs.update(this.originalTabId, { active: true });
                    }
                    catch (error) {
                        console.log("Original tab no longer exists");
                    }
                }
                // Reset tab IDs
                this.currentTabId = null;
                this.originalTabId = null;
                // Remove the listener
                chrome.tabs.onRemoved.removeListener(this.handleTabRemoval);
            }
        };
    }
    async performCollection(accountId, URL) {
        let tab = null;
        let currentTabId = null;
        try {
            // Get auth method from storage
            const { [`authMethod_${accountId}`]: authMethod = "email" } = await chrome.storage.local.get(`authMethod_${accountId}`);
            console.log(`📝 Using auth method for ${accountId}:`, authMethod);
            // Create the tab and wait for it to be ready
            console.log(`🔄 Creating tab for ${accountId}`);
            tab = await chrome.tabs.create({ url: URL });
            if (!tab.id)
                throw new Error("Failed to create tab");
            currentTabId = tab.id;
            // Wait for tab to load
            console.log(`⏳ Waiting for tab ${currentTabId} to load`);
            await this.waitForTabLoad(currentTabId);
            // Initial delay after page load
            console.log("Applying initial delay...");
            await new Promise((resolve) => setTimeout(resolve, 9000));
            // Execute action sequence
            console.log(`▶️ Starting action sequence for ${accountId}`);
            const actions = await this.getActionSequence(accountId, authMethod);
            await this.executeActions(currentTabId, actions);
            console.log(`✅ Collection completed for ${accountId}`);
            return true;
        }
        catch (error) {
            console.log(`⚠️ Collection error for ${accountId}:`, error);
            return true; // Return true anyway to avoid marking as failed
        }
        finally {
            // Cleanup
            try {
                if (currentTabId) {
                    try {
                        await chrome.tabs.remove(currentTabId);
                    }
                    catch (e) {
                        console.log(`Tab ${currentTabId} was already closed`);
                    }
                }
            }
            catch (cleanupError) {
                console.log(`Cleanup error for ${accountId}:`, cleanupError);
            }
        }
    }
    async waitForTabLoad(tabId) {
        return new Promise((resolve, reject) => {
            // let timeoutId: NodeJS.Timeout;
            function listener(id, info) {
                if (id === tabId && info.status === "complete") {
                    chrome.tabs.onUpdated.removeListener(listener);
                    // clearTimeout(timeoutId);
                    resolve();
                }
            }
            chrome.tabs.onUpdated.addListener(listener);
        });
    }
    async executeActions(tabId, actions) {
        const sequenceId = `seq_${tabId}_${Date.now()}`;
        console.log(`🔄 Starting sequence ${sequenceId}`);
        // Track completed actions
        const completedActions = new Set();
        for (const action of actions) {
            try {
                // Verify tab before each action
                await this.verifyTab(tabId);
                // Generate unique action ID
                const actionId = `${sequenceId}_${action.action}_${Date.now()}`;
                // Skip if this exact action was already completed
                if (completedActions.has(actionId)) {
                    console.log(`⏭️ [${sequenceId}] Skipping already completed action:`, action.action);
                    continue;
                }
                const actionDuration = action.duration
                    ? parseInt(action.duration)
                    : "default";
                console.log(`🎯 [${sequenceId}] Starting action:`, {
                    type: action.action,
                    duration: actionDuration,
                    actionId,
                    ...(action.textContents && { textContents: action.textContents }),
                });
                // Execute the action with retries
                let actionCompleted = false;
                let attempts = 0;
                const maxAttempts = 3;
                while (!actionCompleted && attempts < maxAttempts) {
                    attempts++;
                    console.log(`▶️ [${sequenceId}] Executing action (attempt ${attempts}):`, action.action);
                    try {
                        // Quick ready check
                        const readyCheck = await this.sendTabMessage(tabId, {
                            action: "ping",
                        });
                        if (!readyCheck?.ready) {
                            console.log(`⏳ [${sequenceId}] Content script busy, waiting...`);
                            await new Promise((resolve) => setTimeout(resolve, 2000));
                            continue;
                        }
                        // Send action with ID and wait for completion
                        const response = await this.sendTabMessage(tabId, {
                            action: "executeAction",
                            actionDetails: {
                                ...action,
                                actionId,
                            },
                        });
                        if (response?.status === "rejected") {
                            console.log(`⏳ [${sequenceId}] Action rejected - retrying...`);
                            await new Promise((resolve) => setTimeout(resolve, 2000));
                            continue;
                        }
                        // Wait for explicit completion via ACTION_STATUS
                        const actionResult = await new Promise((resolve, reject) => {
                            const timeout = setTimeout(() => {
                                reject(new Error("Action completion timeout"));
                            }, 10000);
                            const messageListener = (msg) => {
                                if (msg.type === "ACTION_STATUS" && msg.actionId === actionId) {
                                    clearTimeout(timeout);
                                    chrome.runtime.onMessage.removeListener(messageListener);
                                    resolve(msg);
                                }
                            };
                            chrome.runtime.onMessage.addListener(messageListener);
                        });
                        console.log(`✅ [${sequenceId}] Action completed:`, actionResult);
                        actionCompleted = true;
                        completedActions.add(actionId);
                        // Apply post-action delay
                        const postActionDelay = this.calculateActionDelay(action);
                        console.log(`⏳ [${sequenceId}] Post-action delay: ${postActionDelay}ms`);
                        await new Promise((resolve) => setTimeout(resolve, postActionDelay));
                    }
                    catch (error) {
                        console.log(`⚠️ [${sequenceId}] Action attempt ${attempts} failed:`, error);
                        if (attempts < maxAttempts) {
                            await new Promise((resolve) => setTimeout(resolve, 2000));
                        }
                        else {
                            actionCompleted = true;
                            console.log(`⚠️ [${sequenceId}] Moving on after ${maxAttempts} failed attempts`);
                        }
                    }
                }
            }
            catch (error) {
                console.log(`⚠️ [${sequenceId}] Action failed but continuing:`, error);
                await new Promise((resolve) => setTimeout(resolve, 2000));
            }
        }
        // Complete the sequence
        try {
            const finalActionId = `${sequenceId}_complete_${Date.now()}`;
            console.log(`🏁 [${sequenceId}] Completing sequence`);
            await this.sendTabMessage(tabId, {
                action: "executeAction",
                actionDetails: {
                    action: "sequenceComplete",
                    duration: 1000,
                    actionId: finalActionId,
                },
            });
        }
        catch (error) {
            console.log(`⚠️ [${sequenceId}] Failed to complete sequence:`, error);
        }
    }
    calculateActionDelay(action) {
        const specifiedDuration = action.duration
            ? parseInt(action.duration)
            : undefined;
        // Base delays for each action type
        const BASE_DELAYS = {
            type: 8000, // Base typing time
            clickButton: 5000, // Base click time
            navigate: 7000, // Base navigation time
            findVal: 4000, // Base find time
            sequenceComplete: 1000,
        };
        // Calculate final delay
        const baseDelay = BASE_DELAYS[action.action] || 3000;
        // Use specified duration if provided, otherwise use calculated base delay
        return specifiedDuration || baseDelay;
    }
    async verifyTab(tabId) {
        const tab = await chrome.tabs.get(tabId);
        if (!tab || !tab.url?.startsWith("http")) {
            throw new Error(`Tab ${tabId} is not ready or not a valid http(s) page`);
        }
        // Verify content script is ready by sending a ping
        try {
            await this.sendTabMessage(tabId, { action: "ping" });
        }
        catch (error) {
            throw new Error(`Content script not ready in tab ${tabId}`);
        }
    }
    async sendTabMessage(tabId, message) {
        return new Promise((resolve, reject) => {
            const timeoutId = setTimeout(() => reject(new Error("Message timed out")), 5000 // Reduced from 20000 to 5000ms
            );
            try {
                chrome.tabs.sendMessage(tabId, message, (response) => {
                    clearTimeout(timeoutId);
                    if (chrome.runtime.lastError) {
                        reject(chrome.runtime.lastError);
                    }
                    else {
                        resolve(response);
                    }
                });
            }
            catch (e) {
                clearTimeout(timeoutId);
                reject(e);
            }
        });
    }
    async getActionSequence(accountId, authMethod) {
        const sequences = accountActionSequences[accountId];
        if (!sequences)
            throw new Error(`No action sequence found for account: ${accountId}`);
        const selectedSequence = sequences[authMethod];
        if (!selectedSequence || !Array.isArray(selectedSequence)) {
            throw new Error(`No ${authMethod} sequence found for account: ${accountId}`);
        }
        return selectedSequence;
    }
    async handleTabSwitch(urlPattern) {
        try {
            // Get all tabs
            const tabs = await chrome.tabs.query({});
            // Find tabs matching the pattern, sorted by most recently created
            const matchingTabs = tabs
                .filter((tab) => tab.url?.includes(urlPattern))
                .sort((a, b) => (b.id || 0) - (a.id || 0));
            if (matchingTabs.length === 0) {
                return { success: false, error: "No matching tab found" };
            }
            // Store current tab if not already stored
            if (!this.originalTabId) {
                const [currentTab] = await chrome.tabs.query({
                    active: true,
                    currentWindow: true,
                });
                this.originalTabId = currentTab?.id || null;
            }
            // Get the most recent matching tab
            const targetTab = matchingTabs[0];
            if (!targetTab.id) {
                return { success: false, error: "Invalid tab ID" };
            }
            // Switch to the target tab
            await chrome.tabs.update(targetTab.id, { active: true });
            this.currentTabId = targetTab.id;
            // Set up tab removal listener if not already set
            this.setupTabRemovalListener();
            return { success: true, tabId: targetTab.id };
        }
        catch (error) {
            console.error("Tab switch error:", error);
            return { success: false, error: String(error) };
        }
    }
    setupTabRemovalListener() {
        // Remove existing listener if any
        chrome.tabs.onRemoved.removeListener(this.handleTabRemoval);
        // Add new listener
        chrome.tabs.onRemoved.addListener(this.handleTabRemoval);
    }
}
CollectionManager.LOCK_PREFIX = "collection_lock_";

/******/ })()
;
//# sourceMappingURL=background.js.map